/*************************************************
t@CFComponent.h
쐬ҁ@@Fт
@@@FeR|[lg
*************************************************/
/**
*	@file	Component.h
*	@brief	eR|[lg֌WłB
*/
#ifndef ABYSSLIB_COMPONENT_H
#define ABYSSLIB_COMPONENT_H

namespace nsAbyssLib{
namespace nsComponent{

//eR|[lg̗񋓌^
/**
*	@brief	eR|[lg̗񋓌^łB
*/
enum UICOMPONENT_TYPE{
/**
*	@brief	o[i`jłB
*/
	UICOMPONENT_BAR_DRAW,																			//o[i`j

/**
*	@brief	{^i`jłB
*/
	UICOMPONENT_BUTTON_DRAW,																		//{^i`j
};

//R|[lgNXiC^[tF[Xj
/**
*	@brief	R|[lgNX̃C^[tF[XłB
*/
class IUIComponent{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~IUIComponent(){}																		//zfXgN^

/**
*	@brief	`s܂B
*
*			`s悤ɎĂB
*/
	virtual void OnDraw() = 0;																		//`
/**
*	@brief	s܂B
*
*			s悤ɎĂB
*/
	virtual bool OnMove() = 0;																		//m
/**
*	@brief	R|[lghc擾܂B
*
*			R|[lghc擾悤ɎĂB<br>
*			R|[lgVK쐬ۂɗpӂ0ȏ̈ӂȒlԂ΂njłB
*	@return	{NX̃R|[lghcԂ܂B<br>
*			NX̎ޖ0ȏ̈ӂȒlԂĂB<br>
*			R|[lgVK쐬ۂɗpӂ0ȏ̈ӂȒlԂ΂njłB
*/
	virtual int GetID() const = 0;																	//ނ擾
};

//o[i`jNX
/**
*	@brief	o[i`jNXłB
*/
class UICBarDraw : public IUIComponent{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	UICBarDraw();																					//ftHgRXgN^
/**
*	@brief	RXgN^łB
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	UICBarDraw(NovelPlayer* Parent);																//RXgN^

/**
*	@brief	eGWݒ肵܂B
*
*			{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B<br>
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	void SetParent(NovelPlayer* Parent);															//eGWݒ

/**
*	@brief	{R|[lgԂ擾܂B
*	@return	{R|[lgԂԂ܂B<br>
*			Ԃ̏ꍇtrueAłȂꍇfalseԂ܂B
*/
	bool GetDisable() const;																		//擾
/**
*	@brief	{R|[lgԂݒ肵܂B
*	@param	IsDisable	[in]{R|[lgԂw肵܂B<br>
*						truȅꍇ͖ԁAfalsȅꍇ͗LԂƂȂ܂B
*/
	void SetDisable(bool IsDisable);																//ݒ

/**
*	@brief	o[ݎĂ銄擾܂B
*	@return	o[ݎĂ銄Ԃ܂B<br>
*			߂l͈̔͂0`10000łB
*/
	unsigned int GetRate() const;																	//擾(0-10000)
/**
*	@brief	o[ݎĂ銄ݒ肵܂B
*	@param	Rate	[in]o[ݎĂ銄w肵܂B<br>
*					w\Ȓl͈̔͂0`10000łB͈͊Ȍꍇ\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[	\endlink܂B
*/
	void SetRate(unsigned int Rate);																//ݒ(0-10000)

/**
*	@brief	o[̘g̑ݒ肵܂B
*	@param	Border	[in]o[̘g̑w肵܂B
*/
	void SetBorder(unsigned int Border);															//gݒ
/**
*	@brief	o[̊Oςݒ肵܂B
*	@param	Rect	[in]o[̈ʒuw肵܂B
*	@param	Knob	[in]܂݂̌`w肵܂B
*	@param	a		[in]ߓxw肵܂B
*/
	void SetPosition(RECT Rect, RECT Knob, BYTE a);													//Wݒ
/**
*	@brief	o[̂rdݒ肵܂B
*	@param	OnCursor	[in]J[\rdw肵܂B
*	@param	OnClick		[in]NbNrdw肵܂B
*/
	void SetSound(const string& OnCursor, const string& OnClick);									//SEݒ
/**
*	@brief	o[̓Fݒ肵܂B
*	@param	Normal		[in]ʏ펞̓Fw肵܂B
*	@param	OnCursor	[in]J[\̓Fw肵܂B
*	@param	OnHold		[in]NbN̓Fw肵܂B
*	@param	Disable		[in]̓Fw肵܂B
*/
	void SetBarColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable);		//Fݒ
/**
*	@brief	o[̘g̐Fݒ肵܂B
*	@param	Normal		[in]ʏ펞̘g̐Fw肵܂B
*	@param	OnCursor	[in]J[\̘g̐Fw肵܂B
*	@param	OnHold		[in]NbN̘g̐Fw肵܂B
*	@param	Disable		[in]̘g̐Fw肵܂B
*/
	void SetBorderColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable);		//g̐Fݒ

	void OnDraw();																					//`
	bool OnMove();																					//m
	int GetID() const;																				//ނ擾
private:
	NovelPlayer* Outer;																				//eGW̃AhX
	bool m_IsDisable;																				//H
	unsigned int m_Rate;																			//(1-10000)
	unsigned int m_Border;																			//g̑
	RECT m_Rect;																					//聕``io[j
	RECT m_Knob;																					//聕``imuj
	BYTE m_a;																						//ߓx
	string m_CursorSE, m_ClickSE;																	//SEiJ[\/NbNj
	COLORREF m_NColor, m_CColor, m_HColor, m_DColor;												//F
	COLORREF m_BorderNColor, m_BorderCColor, m_BorderHColor, m_BorderDColor;						//g̐F
	bool m_IsCursored;																				//J[\mp
	bool m_IsPushed;																				//NbNmp

	UICBarDraw(const UICBarDraw&);																	//Rs[RXgN^i֎~j
	UICBarDraw& operator =(const UICBarDraw&);														//Zqi֎~j
};

//{^i`jNX
/**
*	@brief	{^i`jNXłB
*/
class UICButtonDraw : public IUIComponent{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	UICButtonDraw();																				//ftHgRXgN^
/**
*	@brief	RXgN^łB
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	UICButtonDraw(NovelPlayer* Parent);																//RXgN^

/**
*	@brief	eGWݒ肵܂B
*
*			{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B<br>
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	void SetParent(NovelPlayer* Parent);															//eGWݒ

/**
*	@brief	{R|[lgԂ擾܂B
*	@return	{R|[lgԂԂ܂B<br>
*			Ԃ̏ꍇtrueAłȂꍇfalseԂ܂B
*/
	bool GetDisable() const;																		//擾
/**
*	@brief	{R|[lgԂݒ肵܂B
*	@param	IsDisable	[in]{R|[lgԂw肵܂B<br>
*						truȅꍇ͖ԁAfalsȅꍇ͗LԂƂȂ܂B
*/
	void SetDisable(bool IsDisable);																//ݒ

/**
*	@brief	{^̘g̑ݒ肵܂B
*	@param	Border	[in]{^̘g̑w肵܂B
*/
	void SetBorder(unsigned int Border);															//gݒ
/**
*	@brief	{^̊Oςݒ肵܂B
*	@param	Rect	[in]{^̈ʒuw肵܂B
*	@param	a		[in]ߓxw肵܂B
*/
	void SetPosition(RECT Rect, BYTE a);															//Wݒ
/**
*	@brief	{^̂rdݒ肵܂B
*	@param	OnCursor	[in]J[\rdw肵܂B
*	@param	OnClick		[in]NbNrdw肵܂B
*/
	void SetSound(const string& OnCursor, const string& OnClick);									//SEݒ
/**
*	@brief	{^̃eLXgݒ肵܂B
*	@param	Text	[in]eLXgw肵܂B
*	@param	Font	[in]tHgw肵܂B
*	@param	Size	[in]TCYw肵܂B
*/
	void SetText(const string& Text, const string& Font, unsigned int Size);						//eLXgݒ
/**
*	@brief	{^̕Fݒ肵܂B
*	@param	Normal		[in]ʏ펞̕Fw肵܂B
*	@param	OnCursor	[in]J[\̕Fw肵܂B
*	@param	OnHold		[in]NbN̕Fw肵܂B
*	@param	Disable		[in]̕Fw肵܂B
*/
	void SetTextColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable);		//eLXg̐Fݒ
/**
*	@brief	{^̓Fݒ肵܂B
*	@param	Normal		[in]ʏ펞̓Fw肵܂B
*	@param	OnCursor	[in]J[\̓Fw肵܂B
*	@param	OnHold		[in]NbN̓Fw肵܂B
*	@param	Disable		[in]̓Fw肵܂B
*/
	void SetButtonColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable);		//Fݒ
/**
*	@brief	{^̘g̐Fݒ肵܂B
*	@param	Normal		[in]ʏ펞̘g̐Fw肵܂B
*	@param	OnCursor	[in]J[\̘g̐Fw肵܂B
*	@param	OnHold		[in]NbN̘g̐Fw肵܂B
*	@param	Disable		[in]̘g̐Fw肵܂B
*/
	void SetBorderColor(COLORREF Normal, COLORREF OnCursor, COLORREF OnHold, COLORREF Disable);		//g̐Fݒ

	void OnDraw();																					//`
	bool OnMove();																					//m
	int GetID() const;																				//ނ擾
private:
	NovelPlayer* Outer;																				//eGW̃AhX
	bool m_IsDisable;																				//H
	unsigned int m_Border;																			//g̑
	RECT m_Rect;																					//聕``
	BYTE m_a;																						//ߓx
	string m_CursorSE, m_ClickSE;																	//SEiJ[\/NbNj
	string m_Text;																					//eLXg
	string m_Font;																					//tHg
	unsigned int m_Size;																			//TCY
	COLORREF m_TextNColor, m_TextCColor, m_TextHColor, m_TextDColor;								//eLXg̐F
	COLORREF m_NColor, m_CColor, m_HColor, m_DColor;												//F
	COLORREF m_BorderNColor, m_BorderCColor, m_BorderHColor, m_BorderDColor;						//g̐F
	bool m_IsCursored;																				//J[\mp
	bool m_IsPushed;																				//NbNmp

	UICButtonDraw(const UICButtonDraw&);															//Rs[RXgN^i֎~j
	UICButtonDraw& operator =(const UICButtonDraw&);												//Zqi֎~j
};

}
}

#endif