/*************************************************
t@CFDrawManager.h
쐬ҁ@@Fт
@@@FOtBbN֘A
*************************************************/
/**
*	@file	DrawManager.h
*	@brief	OtBbN֘AłB
*/
#ifndef ABYSSLIB_DRAWMANAGER_H
#define ABYSSLIB_DRAWMANAGER_H

namespace nsAbyssLib{

namespace nsCore{
//ˑNXiQƐFAbyssLib.hj
class INovelEngine;
}

namespace nsDrawManager{

//eLXgJ[\̏
/**
*	@brief	eLXgJ[\̏Ԃ\񋓌^łB
*
*			eLXgJ[\Ƃ́AeLXg̖ɕtACR̂ƂłB
*/
enum TEXTCURSOR{
/**
*	@brief	ʏ펞̃eLXgJ[\łB
*
*			ʏ펞Ƃ́AL񋓒萔ŕ\ĂԈȊO̎̂ƂłB
*/
	TEXTCURSOR_NONE,																		//ʏ
/**
*	@brief	NbN҂̃eLXgJ[\łB
*
*			NbN҂Ƃ́AeLXg߂ŃNbN҂ɂȂĂ鎞̂ƂłB
*/
	TEXTCURSOR_CLICK,																		//NbN҂
/**
*	@brief	y[W҂̃eLXgJ[\łB
*
*			y[W҂Ƃ́AeLXgSĕ\Iy[W҂ɂȂĂ鎞̂ƂłB
*/
	TEXTCURSOR_GONEXT,																		//y[W҂
/**
*	@brief	Ǘ̃eLXgJ[\łB
*
*			ǗƂ́AǗ\Ă鎞̂ƂłB
*/
	TEXTCURSOR_BACKLOG,																		//Ǘ
};

//OtBbNpfoCXiC^[tF[Xj
/**
*	@brief	OtBbNpfoCXNX̃C^[tF[XłB
*
*			{NX͑SẴOtBbNs܂B<br>
*			e\bh̐QlɁA\link	nsAbyssLib::nsDrawManager::BaseDrawManager	BaseDrawManager\endlinkNXpċۃNX쐬ĂB
*/
class IDrawManager{
public:
	//摜
/**
*	@brief	{NXŕێĂSẲ摜t@C܂B
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool UnloadAllImage() = 0;														//S摜
/**
*	@brief	摜t@Cǂݍݖ{NXŕێ܂B
*	@param	FileName	[in]t@Cw肵܂B
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool LoadImage(const char* FileName) = 0;										//摜ɓǂݍ
/**
*	@brief	{NXŕێĂ摜t@C܂B
*	@param	FileName	[in]t@Cw肵܂B
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool UnloadImage(const char* FileName) = 0;										//摜
	//
/**
*	@brief	NCAgʂ̉擾܂B
*
*			擾悤ɎĂB
*	@return	NCAgʂ̉Ԃ܂B
*/
	virtual unsigned int GetScreenWidth() const = 0;										//ʂ̉擾
/**
*	@brief	NCAgʂ̏c擾܂B
*
*			擾悤ɎĂB
*	@return	NCAgʂ̉Ԃ܂B
*/
	virtual unsigned int GetScreenHeight() const = 0;										//ʂ̏c擾
/**
*	@brief	tXN[擾܂B
*
*			擾悤ɎĂB
*	@return	tXN[Ԃ܂B<br>
*			tXN[[h̏ꍇtrueAEChE[h̏ꍇfalseԂ܂B
*/
	virtual bool GetFullScreen() const = 0;													//tXN[ۂ擾
/**
*	@brief	tXN[ݒ肵܂B
*
*			ݒ肷悤ɎĂB
*	@param	IsFullScreen	[in]tXN[w肵܂B<br>
*							tXN[[hɂꍇtrueAEChE[hɂꍇfalsew肵ĂB
*/
	virtual void SetFullScreen(bool IsFullScreen) = 0;										//tXN[ۂݒ
	//eLXg̕\x
/**
*	@brief	eLXg̕\x擾܂B
*	@return	eLXg̕\xԂ܂B<br>
*			Pʂ(/~b)łB
*/
	virtual int GetTextSpeed() const = 0;													//eLXg̕\x擾
/**
*	@brief	eLXg̕\xݒ肵܂B
*	@param	TextSpeed	[in]eLXg̕\xw肵܂B<br>
*						Pʂ(/~b)łB<br>
*						w肵ꍇA\link	nsAbyssLib::nsDrawManager::IDrawManager::GetTextSpeed	GetTextSpeed\endlink\bh̖߂l
*						\link	nsAbyssLib::nsDrawManager::IDrawManager::GetDefaultTextSpeed	GetDefaultTextSpeed\endlink\bh̖߂lƓɂȂ܂B
*/
	virtual void SetTextSpeed(int TextSpeed) = 0;											//eLXg̕\xݒ
/**
*	@brief	eLXg̃ftHg\x擾܂B
*	@return	eLXg̃ftHg\xԂ܂B<br>
*			Pʂ(/~b)łB
*/
	virtual unsigned int GetDefaultTextSpeed() const = 0;									//eLXg̕\x擾iftHgj
/**
*	@brief	eLXg̃ftHg\xݒ肵܂B
*	@param	DefaultTextSpeed	[in]eLXg̃ftHg\xw肵܂B<br>
*								Pʂ(/~b)łB
*/
	virtual void SetDefaultTextSpeed(unsigned int DefaultTextSpeed) = 0;					//eLXg̕\xݒiftHgj
	//eLXgEChE
/**
*	@brief	eLXgEChE̕\Ԃ擾܂B
*	@return	eLXgEChE̕\ԂԂ܂B<br>
*			\ꍇtrueA\ȂꍇfalseԂ܂B
*/
	virtual bool GetTextWindowShow() const = 0;												//eLXgEChE̕\Ԃ擾
/**
*	@brief	eLXgEChE̕\Ԃݒ肵܂B
*	@param	IsShow	[in]eLXgEChE̕\Ԃw肵܂B<br>
*						\ꍇtrueA\Ȃꍇfalsew肵ĂB
*/
	virtual void SetTextWindowShow(bool IsShow) = 0;										//eLXgEChE̕\Ԃݒ
/**
*	@brief	eLXgEChE̕\ԁi\j擾܂B
*
*			eLXgEChE̕\Ԃ\̏ꍇAeLXgEChE\ɂ邱Ƃł܂B
*	@return	eLXgEChE̕\ԁi\jԂ܂B<br>
*			\̏ꍇtrueA\łȂꍇfalseԂ܂B
*/
	virtual bool GetTextWindowForceShow() const = 0;										//eLXgEChE̕\ԁi\j擾
/**
*	@brief	eLXgEChE̕\ԁi\jݒ肵܂B
*
*			eLXgEChE̕\Ԃ\̏ꍇAeLXgEChE\ɂ邱Ƃł܂B
*	@param	IsForceShow	[in]eLXgEChE̕\ԁi\jw肵܂B<br>
*						\̏ꍇtrueA\łȂꍇfalsew肵ĂB
*/
	virtual void SetTextWindowForceShow(bool IsForceShow) = 0;								//eLXgEChE̕\ԁi\jݒ
/**
*	@brief	摜ŃeLXgEChEݒ肵܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Image		[in]]`w肵܂B<br>
*						w̏ꍇ\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*/
	virtual void SetTextWindow(const char* FileName, int x, int y, BYTE a, RECT Image) = 0;	//eLXgEChEݒi摜j
/**
*	@brief	`ŃeLXgEChEݒ肵܂B
*	@param	Position	[in]`w肵܂B<br>
*						w̏ꍇ\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*	@param	Color		[in]`̓Fw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Border		[in]g̑w肵܂B
*	@param	BorderColor	[in]`̘g̐Fw肵܂B
*/
	virtual void SetTextWindow(RECT Position, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor) = 0;
																							//eLXgEChEݒi`j
	//eLXg/Җ
/**
*	@brief	r̃tHg擾܂B
*	@return	r̃tHgԂ܂B
*/
	virtual const char* GetRubyFont() const = 0;											//r̃tHg擾
/**
*	@brief	r̃tHgݒ肵܂B
*	@param	Font	[in]r̃tHgw肵܂B
*/
	virtual void SetRubyFont(const char* Font) = 0;											//r̃tHgݒ
/**
*	@brief	r̃TCY擾܂B
*	@return	r̃TCYԂ܂B
*/
	virtual unsigned int GetRubySize() const = 0;											//r̃TCY擾
/**
*	@brief	r̃TCYݒ肵܂B
*	@param	Size	[in]r̃TCYw肵܂B
*/
	virtual void SetRubySize(unsigned int Size) = 0;										//r̃TCYݒ
/**
*	@brief	eLXg̍W擾܂B
*	@param	x	[out]wWi[܂B
*	@param	y	[out]xWi[܂B
*/
	virtual void GetTextPos(int& x, int& y) const = 0;										//eLXg̍W擾
/**
*	@brief	eLXg̍Wݒ肵܂B
*	@param	x	[in]wWw肵܂B
*	@param	y	[in]xWw肵܂B
*/
	virtual void SetTextPos(int x, int y) = 0;												//eLXg̍Wݒ
/**
*	@brief	eLXg̍ő剡擾܂B
*
*			ő剡𒴂Ȃ悤ɃeLXgɂ͎ss܂B
*	@return	eLXg̍ő剡Ԃ܂B
*/
	virtual unsigned int GetTextMaxWidth() const = 0;										//eLXg̍ő剡擾
/**
*	@brief	eLXg̍ő剡ݒ肵܂B
*
*			ő剡𒴂Ȃ悤ɃeLXgɂ͎ss܂B
*	@param	Width	[in]eLXg̍ő剡w肵܂B
*/
	virtual void SetTextMaxWidth(unsigned int Width) = 0;									//eLXg̍ő剡ݒ
/**
*	@brief	eLXg̍őc擾܂B
*
*			eLXgőc𒴂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeWarning	x\endlink܂B
*	@return	eLXg̍őcԂ܂B
*/
	virtual unsigned int GetTextMaxHeight() const = 0;										//eLXg̍őc擾
/**
*	@brief	eLXg̍őcݒ肵܂B
*
*			eLXgőc𒴂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeWarning	x\endlink܂B
*	@param	Height	[in]eLXg̍őcw肵܂B
*/
	virtual void SetTextMaxHeight(unsigned int Height) = 0;									//eLXg̍őcݒ
/**
*	@brief	eLXg̃J[擾܂B
*	@return	eLXg̃J[Ԃ܂B
*/
	virtual COLORREF GetTextColor() const = 0;												//eLXg̃J[擾
/**
*	@brief	eLXg̃J[ݒ肵܂B
*	@param	Color	[in]eLXg̃J[w肵܂B
*/
	virtual void SetTextColor(COLORREF Color) = 0;											//eLXg̃J[ݒ
/**
*	@brief	eLXg̃tHg擾܂B
*	@return	eLXg̃tHgԂ܂B
*/
	virtual const char* GetTextFont() const = 0;											//eLXg̃tHg擾
/**
*	@brief	eLXg̃tHgݒ肵܂B
*	@param	Font	[in]eLXg̃tHgw肵܂B
*/
	virtual void SetTextFont(const char* Font) = 0;											//eLXg̃tHgݒ
/**
*	@brief	eLXg̃TCY擾܂B
*	@return	eLXg̃TCYԂ܂B
*/
	virtual unsigned int GetTextSize() const = 0;											//eLXg̃TCY擾iptj
/**
*	@brief	eLXg̃TCYݒ肵܂B
*	@param	Size	[in]eLXg̃TCYw肵܂B
*/
	virtual void SetTextSize(unsigned int Size) = 0;										//eLXg̃TCYݒiptj
/**
*	@brief	Җ̍W擾܂B
*	@param	x	[out]wWi[܂B
*	@param	y	[out]xWi[܂B
*/
	virtual void GetTalkerPos(int& x, int& y) const = 0;									//Җ̍W擾
/**
*	@brief	Җ̍Wݒ肵܂B
*	@param	x	[in]wWw肵܂B
*	@param	y	[in]xWw肵܂B
*/
	virtual void SetTalkerPos(int x, int y) = 0;											//Җ̍Wݒ
/**
*	@brief	Җ̍ő剡擾܂B
*
*			ő剡𒴂Ȃ悤ɔҖɂ͎ss܂B
*	@return	ő剡̍ő剡Ԃ܂B
*/
	virtual unsigned int GetTalkerMaxWidth() const = 0;										//Җ̍ő剡擾
/**
*	@brief	Җ̍ő剡ݒ肵܂B
*
*			ő剡𒴂Ȃ悤ɔҖɂ͎ss܂B
*	@param	Width	[in]Җ̍ő剡w肵܂B
*/
	virtual void SetTalkerMaxWidth(unsigned int Width) = 0;									//Җ̍ő剡ݒ
/**
*	@brief	Җ̍őc擾܂B
*
*			Җőc𒴂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeWarning	x\endlink܂B
*	@return	Җ̍őcԂ܂B
*/
	virtual unsigned int GetTalkerMaxHeight() const = 0;									//Җ̍őc擾
/**
*	@brief	Җ̍őc擾܂B
*
*			Җőc𒴂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeWarning	x\endlink܂B
*	@return	Җ̍őcԂ܂B
*/
	virtual void SetTalkerMaxHeight(unsigned int Height) = 0;								//Җ̍őcݒ
/**
*	@brief	Җ̃J[擾܂B
*	@return	Җ̃J[Ԃ܂B
*/
	virtual COLORREF GetTalkerColor() const = 0;											//Җ̃J[擾
/**
*	@brief	Җ̃J[ݒ肵܂B
*	@param	Color	[in]Җ̃J[w肵܂B
*/
	virtual void SetTalkerColor(COLORREF Color) = 0;										//Җ̃J[ݒ
/**
*	@brief	Җ̃tHg擾܂B
*	@return	Җ̃tHgԂ܂B
*/
	virtual const char* GetTalkerFont() const = 0;											//Җ̃tHg擾
/**
*	@brief	Җ̃tHgݒ肵܂B
*	@param	Font	[in]Җ̃tHgw肵܂B
*/
	virtual void SetTalkerFont(const char* Font) = 0;										//Җ̃tHgݒ
/**
*	@brief	Җ̃TCY擾܂B
*	@return	Җ̃TCYԂ܂B
*/
	virtual unsigned int GetTalkerSize() const = 0;											//Җ̃TCY擾iptj
/**
*	@brief	Җ̃TCYݒ肵܂B
*	@param	Size	[in]Җ̃TCYw肵܂B
*/
	virtual void SetTalkerSize(unsigned int Size) = 0;										//Җ̃TCYݒiptj
/**
*	@brief	eLXg擾܂B
*	@return	eLXgԂ܂B
*/
	virtual const TextTokenSection& GetText() const = 0;									//eLXg擾
/**
*	@brief	eLXgݒ肵܂B
*	@param	Text	[in]eLXgw肵܂B
*/
	virtual void SetText(const TextTokenSection& Text) = 0;									//eLXgݒ
/**
*	@brief	Җ擾܂B
*	@return	ҖԂ܂B
*/
	virtual const TextTokenSection& GetTalker() const = 0;									//Җ擾
/**
*	@brief	Җݒ肵܂B
*	@param	Talker	[in]Җw肵܂B
*/
	virtual void SetTalker(const TextTokenSection& Talker) = 0;								//Җݒ
	//eLXgJ[\
/**
*	@brief	eLXgJ[\̏Ԃݒ肵܂B
*	@param	Mode	[in]eLXgJ[\̏Ԃw肵܂B<br>
*					KA\link	nsAbyssLib::nsDrawManager::TEXTCURSOR	TEXTCURSOR񋓌^\endlinkŎw肵ĂB
*/
	virtual void SetTextCursorMode(unsigned int Mode) = 0;									//eLXgJ[\̏Ԃݒ
/**
*	@brief	eLXgJ[\̊e\Ԃݒ肵܂B
*	@param	None	[in]ʏ펞̕\Ԃw肵܂B<br>
*					\ꍇtrueA\Ȃꍇfalsew肵ĂB
*	@param	Click	[in]NbN҂̕\Ԃw肵܂B<br>
*					\ꍇtrueA\Ȃꍇfalsew肵ĂB
*	@param	GoNext	[in]y[W҂̕\Ԃw肵܂B<br>
*					\ꍇtrueA\Ȃꍇfalsew肵ĂB
*	@param	BackLog	[in]Ǘ̕\Ԃw肵܂B<br>
*					\ꍇtrueA\Ȃꍇfalsew肵ĂB
*/
	virtual void SetTextCursorShow(bool None, bool Click, bool GoNext, bool BackLog) = 0;	//eLXgJ[\̊e\Ԃݒ
/**
*	@brief	ʏ펞̃eLXgJ[\ݒ肵܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Image		[in]]`w肵܂B
*	@param	IsABS		[in]eLXgJ[\̕\ʒu΍Ww肵܂B<br>
*						truȅꍇ͐΍WƂȂ܂B<br>
*						falsȅꍇ̓eLXgȆ΍WƂȂ܂B
*/
	virtual void SetTextCursorNone(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS) = 0;
																							//eLXgJ[\iʏjݒ
/**
*	@brief	NbN҂̃eLXgJ[\ݒ肵܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Image		[in]]`w肵܂B
*	@param	IsABS		[in]eLXgJ[\̕\ʒu΍Ww肵܂B<br>
*						truȅꍇ͐΍WƂȂ܂B<br>
*						falsȅꍇ̓eLXgȆ΍WƂȂ܂B
*/
	virtual void SetTextCursorClick(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS) = 0;
																							//eLXgJ[\iNbN҂jݒ
/**
*	@brief	y[W҂̃eLXgJ[\ݒ肵܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Image		[in]]`w肵܂B
*	@param	IsABS		[in]eLXgJ[\̕\ʒu΍Ww肵܂B<br>
*						truȅꍇ͐΍WƂȂ܂B<br>
*						falsȅꍇ̓eLXgȆ΍WƂȂ܂B
*/
	virtual void SetTextCursorGoNext(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS) = 0;
																							//eLXgJ[\iy[W҂jݒ
/**
*	@brief	Ǘ̃eLXgJ[\ݒ肵܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Image		[in]]`w肵܂B
*	@param	IsABS		[in]eLXgJ[\̕\ʒu΍Ww肵܂B<br>
*						truȅꍇ͐΍WƂȂ܂B<br>
*						falsȅꍇ̓eLXgȆ΍WƂȂ܂B
*/
	virtual void SetTextCursorBackLog(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS) = 0;
																							//eLXgJ[\iǗjݒ
	//I
/**
*	@brief	ĨeLXg̃TCY擾܂B
*	@return	ĨeLXg̃TCYԂ܂B
*/
	virtual unsigned int GetSelectTextSize() const = 0;										//ĨeLXg̃TCY擾
/**
*	@brief	ĨeLXg̃TCYݒ肵܂B
*	@param	Size	[in]ĨeLXg̃TCYw肵܂B
*/
	virtual void SetSelectTextSize(unsigned int Size) = 0;									//ĨeLXg̃TCYݒ
/**
*	@brief	ĨeLXg̃tHg擾܂B
*	@return	ĨeLXg̃tHgԂ܂B
*/
	virtual const char* GetSelectTextFont() const = 0;										//ĨeLXg̃tHg擾
/**
*	@brief	ĨeLXg̃tHgݒ肵܂B
*	@param	Font	[in]ĨeLXg̃tHgw肵܂B
*/
	virtual void SetSelectTextFont(const char* Font) = 0;									//ĨeLXg̃tHgݒ
/**
*	@brief	ĨeLXg̍ő剡擾܂B
*
*			ő剡𒴂Ȃ悤ɑĨeLXgɂ͎ss܂B
*	@return	ĨeLXg̍ő剡Ԃ܂B
*/
	virtual unsigned int GetSelectTextMaxWidth() const = 0;									//ĨeLXg̍ő剡擾
/**
*	@brief	ĨeLXg̍ő剡ݒ肵܂B
*
*			ő剡𒴂Ȃ悤ɑĨeLXgɂ͎ss܂B
*	@param	Width	[in]ĨeLXg̍ő剡w肵܂B
*/
	virtual void SetSelectTextMaxWidth(unsigned int Width) = 0;								//ĨeLXg̍ő剡ݒ
/**
*	@brief	ĨeLXg̍őc擾܂B
*
*			ĨeLXgőc𒴂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeWarning	x\endlink܂B
*	@return	ĨeLXg̍őcԂ܂B
*/
	virtual unsigned int GetSelectTextMaxHeight() const = 0;								//ĨeLXg̍őc擾
/**
*	@brief	ĨeLXg̍őcݒ肵܂B
*
*			ĨeLXgőc𒴂ꍇA\link	nsAbyssLib::nsFMisc::RuntimeWarning	x\endlink܂B
*	@param	Height	[in]ĨeLXg̍őcw肵܂B
*/
	virtual void SetSelectTextMaxHeight(unsigned int Height) = 0;							//ĨeLXg̍őcݒ
/**
*	@brief	ĨeLXg̃J[iʏ펞jݒ肵܂B
*	@param	Color	[in]ĨeLXg̃J[iʏ펞jw肵܂B
*/
	virtual void SetSelectTextNColor(COLORREF Color) = 0;									//ĨeLXg̃J[iʏ펞jݒ
/**
*	@brief	ĨeLXg̃J[iIɃ}EXJ[\jݒ肵܂B
*	@param	Color	[in]ĨeLXg̃J[iIɃ}EXJ[\jw肵܂B
*/
	virtual void SetSelectTextCColor(COLORREF Color) = 0;									//ĨeLXg̃J[iJ[\jݒ
/**
*	@brief	ĨeLXg̃J[iIŃ{^܂ꂽjݒ肵܂B
*	@param	Color	[in]ĨeLXg̃J[iIŃ{^܂ꂽjw肵܂B
*/
	virtual void SetSelectTextHColor(COLORREF Color) = 0;									//ĨeLXg̃J[iz[hjݒ
/**
*	@brief	IƉʉ[̊Ԋuݒ肵܂B
*
*			eLXgEChEƑIdȂ荇Ȃ߂̊Ԋuݒ肵܂B
*	@param	Space	[in]IƉʉ[̊Ԋuw肵܂B
*/
	virtual void SetSelectWindowUnderSpace(unsigned int Space) = 0;							//ĨEChEƉʉ[̊Ԋuݒ
/**
*	@brief	IŃ{^܂ꂽ̌ʉݒ肵܂B
*	@param	FileName	[in]t@Cw肵܂B
*/
	virtual void SetSelectClickSE(const char* FileName) = 0;								//ISEiNbNjݒ
/**
*	@brief	IɃ}EXJ[\̌ʉݒ肵܂B
*	@param	FileName	[in]t@Cw肵܂B
*/
	virtual void SetSelectCursorSE(const char* FileName) = 0;								//ISEiJ[\jݒ
/**
*	@brief	摜őIݒ肵܂B
*
*			nԖڂ̑I̋`͈ȉ̂悤ɂȂ܂B<br>
*			wF(Normal.right or OnCursor.right or OnHold.right) - (Normal.left or OnCursor.left or OnHold.left)<br>
*			hF(Normal.bottom or OnCursor.bottom or OnHold.bottom) - (Normal.top or OnCursor.top or OnHold.top)<br>
*			xF((NCAgʂ̉) - w) / 2<br>
*			yF(((NCAgʂ̏c) - (IƉʉ[̊Ԋu) - h * (I̐)) / (I̐) + 1) * (n + 1)) + (h * n)
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Normal		[in]ʏ펞̓]`w肵܂B
*	@param	OnCursor	[in]IɃ}EXJ[\̓]`w肵܂B
*	@param	OnHold		[in]IŃ{^܂ꂽ̓]`w肵܂B
*/
	virtual void SetSelectWindow(const char* FileName, BYTE a, RECT Normal, RECT OnCursor, RECT OnHold) = 0;
																							//Iݒi摜j
/**
*	@brief	`őIݒ肵܂B
*
*			nԖڂ̑I̋`͈ȉ̂悤ɂȂ܂B<br>
*			wF((ĨeLXg̍ő剡) + (eLXgƘg̊Ԋu) * 2)<br>
*			hF((ĨeLXg̍őc) + (eLXgƘg̊Ԋu) * 2)<br>
*			leftF((NCAgʂ̉) - w) / 2<br>
*			topF(((NCAgʂ̏c) - (IƉʉ[̊Ԋu) - h * (I̐)) / (I̐) + 1) * (n + 1)) + (h * n)<br>
*			rightFleft + w<br>
*			bottomFtop + h<br>
*	@param	AroundSpace		[in]eLXgƘg̊Ԋuw肵܂B
*	@param	NColor			[in]`̓Fiʏ펞jw肵܂B
*	@param	CColor			[in]`̓FiIɃ}EXJ[\jw肵܂B
*	@param	HColor			[in]`̓FiIŃ{^܂ꂽjw肵܂B
*	@param	a				[in]ߓxw肵܂B
*	@param	Border			[in]g̑w肵܂B
*	@param	BorderNColor	[in]`̘g̐Fiʏ펞jw肵܂B
*	@param	BorderCColor	[in]`̘g̐FiIɃ}EXJ[\jw肵܂B
*	@param	BorderHColor	[in]`̘g̐FiIŃ{^܂ꂽjw肵܂B
*/
	virtual void SetSelectWindow(unsigned int AroundSpace, COLORREF NColor, COLORREF CColor, COLORREF HColor, BYTE a, unsigned int Border, COLORREF BorderNColor, COLORREF BorderCColor, COLORREF BorderHColor) = 0;
																							//Iݒi`j
/**
*	@brief	ỈԂmF擾܂B
*	@return	ỈԂԂ܂B<br>
*			ԁiIꂽj̏ꍇtrueAłȂꍇfalseԂ܂B
*/
	virtual bool CheckSelect() = 0;															//ỈԂ𒲂ׂ
/**
*	@brief	Iݒ肵܂B
*	@param	Var		[in]Iʂϐ܂͊Oϐ̃V{w肵܂B
*	@param	NumText	[in]I̐w肵܂B
*	@param	Text	[in]ĨeLXg̔zw肵܂B
*/
	virtual void SetSelect(const char* Var, unsigned int NumText, const TextTokenSection Text[]) = 0;	
																							//Iݒ
/**
*	@brief	I܂B
*/
	virtual void ClearSelect() = 0;															//I
	//ʂ
/**
*	@brief	ʂ̏F擾܂B
*
*			{\bh̖߂l\link	nsAbyssLib::nsDrawManager::IDrawManager::SetClearColor	SetClearColor\endlink\bhŎw肵lłB<br>
*			uۂ́vʂ̏Fł͂܂iuۂ́vʂ̏F̎擾Eݒ胁\bh͉BĂ܂j
*	@return	ʂ̏FԂ܂B
*/
	virtual COLORREF GetClearColor() const = 0;												//ʂ̏Fiݒj擾
/**
*	@brief	ʂ̏Fݒ肵܂B
*
*			{\bhŐݒ肷̂́uۂ́vʂ̏Fł͂܂iuۂ́vʂ̏F̎擾Eݒ胁\bh͉BĂ܂j
*	@param	Color	[in]ʂ̏Fw肵܂B
*/
	virtual void SetClearColor(COLORREF Color) = 0;											//ʂ̏Fiݒjݒ
	//̑
/**
*	@brief	t@CݎgpĂ邩擾܂B
*	@param	FileName	[in]t@Cw肵܂B
*	@return	t@CݎgpĂ邩Ԃ܂B<br>
*			gpĂꍇtrueAłȂꍇfalseԂ܂B
*/
	virtual bool IsUsedSE(const char* FileName) const = 0;									//SEgpĂ邩H
/**
*	@brief	摜t@CݎgpĂ邩擾܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@return	摜t@CݎgpĂ邩Ԃ܂B<br>
*			gpĂꍇtrueAłȂꍇfalseԂ܂B
*/
	virtual bool IsUsedImage(const char* FileName) const = 0;								//摜gpĂ邩H
};

//OtBbNpfoCX
/**
*	@brief	OtBbNpfoCX̊NXłB
*
*			ꍇ͖{NXp悤ɂĂB
*/
class BaseDrawManager : public IDrawManager{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	BaseDrawManager();																		//ftHgRXgN^
/**
*	@brief	zfXgN^łB
*/
	virtual ~BaseDrawManager(){}															//zfXgN^

/**
*	@brief	s܂B
*/
	void Initialize();																		//

/**
*	@brief	eGWݒ肵܂B
*
*			{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B<br>
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	void SetParent(INovelEngine* Parent);													//eGWݒ

	bool UnloadAllImage();																	//S摜
	bool LoadImage(const char* FileName);													//摜ɓǂݍ
	bool UnloadImage(const char* FileName);													//摜

	int GetTextSpeed() const;																//eLXg̕\x擾
	void SetTextSpeed(int TextSpeed);														//eLXg̕\xݒ
	unsigned int GetDefaultTextSpeed() const;												//eLXg̕\x擾iftHgj
	void SetDefaultTextSpeed(unsigned int DefaultTextSpeed);								//eLXg̕\xݒiftHgj

	bool GetTextWindowShow() const;															//eLXgEChE̕\Ԃ擾
	void SetTextWindowShow(bool IsShow);													//eLXgEChE̕\Ԃݒ
	bool GetTextWindowForceShow() const;													//eLXgEChE̕\ԁi\j擾
	void SetTextWindowForceShow(bool IsForceShow);											//eLXgEChE̕\ԁi\jݒ
	void SetTextWindow(const char* FileName, int x, int y, BYTE a, RECT Image);				//eLXgEChEݒi摜j
	void SetTextWindow(RECT Position, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor);
																							//eLXgEChEݒi`j

	const char* GetRubyFont() const;														//r̃tHg擾
	void SetRubyFont(const char* Font);														//r̃tHgݒ
	unsigned int GetRubySize() const;														//r̃TCY擾
	void SetRubySize(unsigned int Size);													//r̃TCYݒ
	void GetTextPos(int& x, int& y) const;													//eLXg̍W擾
	void SetTextPos(int x, int y);															//eLXg̍Wݒ
	unsigned int GetTextMaxWidth() const;													//eLXg̍ő剡擾
	void SetTextMaxWidth(unsigned int Width);												//eLXg̍ő剡ݒ
	unsigned int GetTextMaxHeight() const;													//eLXg̍őc擾
	void SetTextMaxHeight(unsigned int Height);												//eLXg̍őcݒ
	COLORREF GetTextColor() const;															//eLXg̃J[擾
	void SetTextColor(COLORREF Color);														//eLXg̃J[ݒ
	const char* GetTextFont() const;														//eLXg̃tHg擾
	void SetTextFont(const char* Font);														//eLXg̃tHgݒ
	unsigned int GetTextSize() const;														//eLXg̃TCY擾iptj
	void SetTextSize(unsigned int Size);													//eLXg̃TCYݒiptj
	void GetTalkerPos(int& x, int& y) const;												//Җ̍W擾
	void SetTalkerPos(int x, int y);														//Җ̍Wݒ
	unsigned int GetTalkerMaxWidth() const;													//Җ̍ő剡擾
	void SetTalkerMaxWidth(unsigned int Width);												//Җ̍ő剡ݒ
	unsigned int GetTalkerMaxHeight() const;												//Җ̍őc擾
	void SetTalkerMaxHeight(unsigned int Height);											//Җ̍őcݒ
	COLORREF GetTalkerColor() const;														//Җ̃J[擾
	void SetTalkerColor(COLORREF Color);													//Җ̃J[ݒ
	const char* GetTalkerFont() const;														//Җ̃tHg擾
	void SetTalkerFont(const char* Font);													//Җ̃tHgݒ
	unsigned int GetTalkerSize() const;														//Җ̃TCY擾iptj
	void SetTalkerSize(unsigned int Size);													//Җ̃TCYݒiptj
	const TextTokenSection& GetText() const;												//eLXg擾
	void SetText(const TextTokenSection& Text);												//eLXgݒ
	const TextTokenSection& GetTalker() const;												//Җ擾
	void SetTalker(const TextTokenSection& Talker);											//Җݒ

	void SetTextCursorMode(unsigned int Mode);												//eLXgJ[\̏Ԃݒ
	void SetTextCursorShow(bool None, bool Click, bool GoNext, bool BackLog);				//eLXgJ[\̊e\Ԃݒ
	void SetTextCursorNone(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS);
																							//eLXgJ[\iʏjݒ
	void SetTextCursorClick(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS);
																							//eLXgJ[\iNbN҂jݒ
	void SetTextCursorGoNext(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS);
																							//eLXgJ[\iy[W҂jݒ
	void SetTextCursorBackLog(const char* FileName, int x, int y, BYTE a, RECT Image, bool IsABS);
																							//eLXgJ[\iǗjݒ

	unsigned int GetSelectTextSize() const;													//ĨeLXg̃TCY擾
	void SetSelectTextSize(unsigned int Size);												//ĨeLXg̃TCYݒ
	const char* GetSelectTextFont() const;													//ĨeLXg̃tHg擾
	void SetSelectTextFont(const char* Font);												//ĨeLXg̃tHgݒ
	unsigned int GetSelectTextMaxWidth() const;												//ĨeLXg̍ő剡擾
	void SetSelectTextMaxWidth(unsigned int Width);											//ĨeLXg̍ő剡ݒ
	unsigned int GetSelectTextMaxHeight() const;											//ĨeLXg̍őc擾
	void SetSelectTextMaxHeight(unsigned int Height);										//ĨeLXg̍őcݒ
	void SetSelectTextNColor(COLORREF Color);												//ĨeLXg̃J[iʏ펞jݒ
	void SetSelectTextCColor(COLORREF Color);												//ĨeLXg̃J[iJ[\jݒ
	void SetSelectTextHColor(COLORREF Color);												//ĨeLXg̃J[iz[hjݒ
	void SetSelectWindowUnderSpace(unsigned int Space);										//ĨEChEƉʉ[̊Ԋuݒ
	void SetSelectClickSE(const char* FileName);											//ISEiNbNjݒ
	void SetSelectCursorSE(const char* FileName);											//ISEiJ[\jݒ
	void SetSelectWindow(const char* FileName, BYTE a, RECT Normal, RECT OnCursor, RECT OnHold);
																							//Iݒi摜j
	void SetSelectWindow(unsigned int AroundSpace, COLORREF NColor, COLORREF CColor, COLORREF HColor, BYTE a, unsigned int Border, COLORREF BorderNColor, COLORREF BorderCColor, COLORREF BorderHColor);
																							//Iݒi`j
	bool CheckSelect();																		//ỈԂ𒲂ׂ
	void SetSelect(const char* Var, unsigned int NumText, const TextTokenSection Text[]);	//Iݒ
	void ClearSelect();																		//I

/**
*	@brief	ʂNA܂B
*/
	void Clear();																			//ʂ
/**
*	@brief	ʂ̏FXV܂B
*
*			\link	nsAbyssLib::nsDrawManager::BaseDrawManager::SetClearColor	SetClearColor\endlink\bhŐݒ肵Fuۂ́vFɔf܂B
*/
	void UpdateClearColor();																//ʂ̏Fi݁jXV
	COLORREF GetClearColor() const;															//ʂ̏Fiݒj擾
	void SetClearColor(COLORREF Color);														//ʂ̏Fiݒjݒ
/**
*	@brief	uۂ́vʂ̏F擾܂B
*	@return	uۂ́vʂ̏FԂ܂B
*/
	COLORREF GetPresentClearColor() const;													//ʂ̏Fi݁j擾
/**
*	@brief	uۂ́vʂ̏Fݒ肵܂B
*	@param	Color	[in]uۂ́vʂ̏Fw肵܂B
*/
	void SetPresentClearColor(COLORREF Color);												//ʂ̏Fi݁jݒ

/**
*	@brief	ʂXV܂B
*
*			XV悤ɎĂB
*/
	virtual void Flip() = 0;
/**
*	@brief	eLXg`悵܂B
*/
	virtual void DrawText();																//eLXg`(1)
/**
*	@brief	eLXg`悵܂B
*	@param	Color	[in]eLXg̃J[w肵܂B
*/
	virtual void DrawText(COLORREF Color);													//eLXg`(2)
/**
*	@brief	Җ`悵܂B
*/
	virtual void DrawTalker();																//Җ`(1)
/**
*	@brief	Җ`悵܂B
*	@param	Color	[in]Җ̃J[w肵܂B
*/
	virtual void DrawTalker(COLORREF Color);												//Җ`(2)
/**
*	@brief	`^XNXg`悵܂B
*/
	virtual void DrawTaskList();															//^XNXg`
/**
*	@brief	eLXgEChE`悵܂B
*/
	virtual void DrawTextWindow();															//eLXgEChE`
/**
*	@brief	eLXgJ[\`悵܂B
*/
	virtual void DrawTextCursor();															//eLXgJ[\`
/**
*	@brief	I`悵܂B
*/
	virtual void DrawSelect();																//I`
/**
*	@brief	gʕ`惁\bhłB
*
*			ERPGƘAgꍇɁAu瑤v̕`֐ĂԂ悤ɎĂB<br>
*			E{\bhŁu瑤v̕`֐ĂԂƂŁA瑤̕`ewiɂ邱Ƃ\łB
*/
	virtual void OnDrawEX(){}																//gʕ`惁\bh

	//ʕ`惁\bh̃wp[(1)
/**
*	@brief	摜̒ʏ]iFjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//ʏ]iFj
/**
*	@brief	摜̉F]iFjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFj
/**
*	@brief	摜̌F]iFjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFj
/**
*	@brief	摜̒ʏ]iFȂjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//ʏ]iFȂj
/**
*	@brief	摜̉F]iFȂjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFȂj
/**
*	@brief	摜̌F]iFȂjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFȂj
	//ʕ`惁\bh̃wp[(2)
/**
*	@brief	̕`s܂B
*	@param	Text	[in]eLXgw肵܂B
*	@param	x		[in]wWw肵܂B
*	@param	y		[in]xWw肵܂B
*	@param	a		[in]ߓxw肵܂B
*/
	void DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a);					//`(1)
/**
*	@brief	̕`s܂B
*	@param	Text	[in]eLXgw肵܂B
*	@param	x		[in]wWw肵܂B
*	@param	y		[in]xWw肵܂B
*	@param	a		[in]ߓxw肵܂B
*	@param	Color	[in]J[w肵܂B
*/
	void DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a, COLORREF Color);	//`(2)
/**
*	@brief	̕`s܂B
*	@param	Text		[in]eLXgw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Font		[in]tHgw肵܂B
*	@param	Size		[in]TCYw肵܂B
*	@param	Color		[in]J[w肵܂B
*	@param	IsBold		[in]w肵܂B<br>
*						̏ꍇtrueAłȂꍇfalsew肵ĂB
*	@param	IsItalic	[in]Α̂w肵܂B<br>
*						Α̂̏ꍇtrueAłȂꍇfalsew肵ĂB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree = 0.0f);
																							//`(3)
	//ʕ`惁\bh̃wp[(3)
/**
*	@brief	`̕`s܂B
*	@param	Rect		[in]`w肵܂B
*	@param	Color		[in]`Fw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	void DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree = 0.0f);					//``
/**
*	@brief	t`̕`s܂B
*	@param	Rect		[in]`w肵܂B
*	@param	Color		[in]Fw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Border		[in]g̑w肵܂B
*	@param	BorderColor	[in]g̐Fw肵܂B
*/
	void DrawBorderRect(RECT Rect, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor);
																							//t``

/**
*	@brief	ݒ̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void SaveE(IIOStream* IOStream);														//ۑiݒj
/**
*	@brief	ݒ̓ǂݍ݂s܂B
*	@param	IOStream				[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*	@param	AllowChangeDisplayMode	[in]ݒ̓ǂݍݎɉʃ[h̕ύX邩w肵܂B<br>
*									ꍇtrueAȂꍇfalsew肵ĂB
*/
	void LoadE(IIOStream* IOStream, bool AllowChangeDisplayMode);							//ǂݍ݁iݒj
/**
*	@brief	[Jݒ̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void SaveL(IIOStream* IOStream);														//ۑi[Jj
/**
*	@brief	[Jݒ̓ǂݍ݂s܂B
*	@param	IOStream				[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void LoadL(IIOStream* IOStream);														//ǂݍ݁i[Jj
	bool IsUsedSE(const char* FileName) const;												//SEgpĂ邩H
	bool IsUsedImage(const char* FileName) const;											//摜gpĂ邩H
protected:
/**
*	@brief	摜t@Cǂݍݖ{NXŕێ܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]t@Cw肵܂B
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool _LoadImage(const char* FileName) = 0;
/**
*	@brief	{NXŕێĂ摜t@C܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]t@Cw肵܂B
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool _UnloadImage(const char* FileName) = 0;
/**
*	@brief	ʂNA܂B
*
*			L̂悤ɎĂB
*/
	virtual void _Clear(COLORREF Color) = 0;
/**
*	@brief	摜̒ʏ]iFjs܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S摜̒SɂȂ悤ɎĂB
*/
	virtual void _Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
/**
*	@brief	摜̉F]iFjs܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S摜̒SɂȂ悤ɎĂB
*/
	virtual void _AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
/**
*	@brief	摜̌F]iFjs܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S摜̒SɂȂ悤ɎĂB
*/
	virtual void _SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
/**
*	@brief	摜̒ʏ]iFȂjs܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S摜̒SɂȂ悤ɎĂB
*/
	virtual void _BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
/**
*	@brief	摜̉F]iFȂjs܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S摜̒SɂȂ悤ɎĂB
*/
	virtual void _AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
/**
*	@brief	摜̌F]iFȂjs܂B
*
*			L̂悤ɎĂB
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S摜̒SɂȂ悤ɎĂB
*/
	virtual void _SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
/**
*	@brief	̕`s܂B
*
*			L̂悤ɎĂB
*	@param	Text		[in]eLXgw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Font		[in]tHgw肵܂B
*	@param	Size		[in]TCYw肵܂B
*	@param	Color		[in]J[w肵܂B
*	@param	IsBold		[in]w肵܂B<br>
*						̏ꍇtrueAłȂꍇfalsew肵ĂB
*	@param	IsItalic	[in]Α̂w肵܂B<br>
*						Α̂̏ꍇtrueAłȂꍇfalsew肵ĂB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S̒SɂȂ悤ɎĂB
*/
	virtual void _DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree) = 0;
/**
*	@brief	`̕`s܂B
*
*			L̂悤ɎĂB
*	@param	Rect		[in]`w肵܂B
*	@param	Color		[in]`Fw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB<br>
*						]̒S`̒SɂȂ悤ɎĂB
*/
	virtual void _DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree) = 0;
private:
	//eGW̃AhX
	INovelEngine* Outer;																	//eGW̃AhX
	//摜
	vector<string> m_ImageName;																//摜
	//eLXg̕\x
	int m_TextSpeed;																		//eLXg̕\x
	unsigned int m_DefaultTextSpeed;														//eLXg̕\xiftHgj
	//eLXgEChEiʁj
	bool m_TextWindowIsShow;																//\
	bool m_TextWindowIsForceShow;															//\ԁi\j
	bool m_TextWindowIsUsedImage;															//`ɉ摜gp邩H
	BYTE m_TextWindowA;																		//ߓx
	//eLXgEChEi摜j
	string m_TextWindowImageName;															//摜
	int m_TextWindowX, m_TextWindowY;														//]W
	RECT m_TextWindowImageSrcRect;															//]`
	//eLXgEChEi`j
	RECT m_TextWindowPosition;																//``
	COLORREF m_TextWindowColor, m_TextWindowBorderColor;									//FAg̐F
	unsigned int m_TextWindowBorder;														//g̑
	//eLXg/Җ
	string m_RubyFont;																		//r̃tHg
	unsigned int m_RubySize;																//r̃TCY
	int m_TextX, m_TextY;																	//eLXg̍W
	int m_TalkerX, m_TalkerY;																//Җ̍W
	unsigned int m_TextMaxWidth, m_TextMaxHeight;											//eLXg̍ő剡/c
	unsigned int m_TalkerMaxWidth, m_TalkerMaxHeight;										//Җ̍ő剡/c
	COLORREF m_TextColor, m_TalkerColor;													//eLXg/Җ̃J[
	string m_TextFont, m_TalkerFont;														//eLXg/Җ̃tHg
	unsigned int m_TextSize, m_TalkerSize;													//eLXg/Җ̃TCY
	TextTokenSection m_Text, m_Talker;														//eLXg/Җ
	//eLXgJ[\
	unsigned int m_TextCursorMode;															//
	bool m_TextCursorIsShowN, m_TextCursorIsShowC, m_TextCursorIsShowG, m_TextCursorIsShowB;
																							//\
	string m_TextCursorImageNameN, m_TextCursorImageNameC, m_TextCursorImageNameG, m_TextCursorImageNameB;
																							//摜
	int m_TextCursorXN, m_TextCursorXC, m_TextCursorXG, m_TextCursorXB;						//]WiXj
	int m_TextCursorYN, m_TextCursorYC, m_TextCursorYG, m_TextCursorYB;						//]WiYj
	BYTE m_TextCursorAN, m_TextCursorAC, m_TextCursorAG, m_TextCursorAB;					//ߓx
	RECT m_TextCursorImageSrcRectN, m_TextCursorImageSrcRectC, m_TextCursorImageSrcRectG, m_TextCursorImageSrcRectB;
																							//]`
	bool m_TextCursorIsABSN, m_TextCursorIsABSC, m_TextCursorIsABSG, m_TextCursorIsABSB;	//Wݒ
	//Iiʁj
	int m_SelectState;																		//
	string m_SelectVar;																		//֘Atϐ
	vector<TextTokenSection> m_SelectText;													//I̕
	unsigned int m_SelectTextSize;															//͂̃TCY
	string m_SelectTextFont;																//͂̃tHg
	vector<bool> m_SelectIsPushed;															//NbNmp
	vector<bool> m_SelectIsCursored;														//J[\mp
	unsigned int m_SelectTextMaxWidth, m_SelectTextMaxHeight;								//eLXg̍ő剡/c
	COLORREF m_SelectTextNColor, m_SelectTextCColor, m_SelectTextHColor;					//eLXg̃J[iʏ펞/J[\/z[hj
	unsigned int m_SelectWindowUnderSpace;													//EChEƉʉ[̊Ԋu
	string m_SelectCursorSE, m_SelectClickSE;												//SEiJ[\/NbNj
	bool m_SelectWindowIsUsedImage;															//`ɉ摜gp邩H
	BYTE m_SelectWindowA;																	//ߓx
	//Ii摜j
	string m_SelectWindowImageName;															//摜
	RECT m_SelectWindowImageSrcRectN, m_SelectWindowImageSrcRectC, m_SelectWindowImageSrcRectH;
																							//]`
	//Ii`j
	unsigned int m_SelectWindowAroundSpace;													//eLXgƘg̊Ԋu
	COLORREF m_SelectWindowNColor, m_SelectWindowCColor, m_SelectWindowHColor;				//Fiʏ펚/J[\/z[hj
	unsigned int m_SelectWindowBorder;														//g̑
	COLORREF m_SelectWindowBorderNColor, m_SelectWindowBorderCColor, m_SelectWindowBorderHColor;
																							//g̐Fiʏ펚/J[\/z[hj
	//ʂ̏F
	COLORREF m_ClearColor;																	//ʂ̏Fiݒj
	COLORREF m_PresentClearColor;															//ʂ̏Fi݁j
};

//OtBbNpfoCXikfoCXj
/**
*	@brief	OtBbNpfoCX̃kfoCXłB
*
*			ikfoCXƂ́AuȂvNX̂Ƃłj
*/
class NullDrawManager : public BaseDrawManager{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	NullDrawManager(){}																		//ftHgRXgN^

	unsigned int GetScreenWidth() const{ return(0); }										//ʂ̉擾
	unsigned int GetScreenHeight() const{ return(0); }										//ʂ̏c擾
	bool GetFullScreen() const{ return(false); }											//tXN[ۂ擾
	void SetFullScreen(bool IsFullScreen){}													//tXN[ۂݒ
	void Flip(){}																			//ʂXV
protected:
	bool _LoadImage(const char* FileName){ return(false); }
	bool _UnloadImage(const char* FileName){ return(false); }
	void _Clear(COLORREF Color){}
	void _Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){}
	void _AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){}
	void _SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){}
	void _BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){}
	void _AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){}
	void _SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree){}
	void _DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree){}
	void _DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree){}
private:
	NullDrawManager(const NullDrawManager&);												//Rs[RXgN^i֎~j
	NullDrawManager& operator =(const NullDrawManager&);									//Zqi֎~j
};

//OtBbNpfoCX̃ANZbTiC^[tF[Xj
/**
*	@brief	BaseDrawManager	NXւ̃ANZbT̃C^[tF[XłB<br>
*			{NXoR	BaseDrawManager	NX̃vCx[go𑀍삷̂͑ϊ댯ȍsׂłB<br>
*			𗝉A\ӂŎgp悤ɂĂB
*/
class IDMAccessor{
public:
/**
*	@brief	ʂNA܂B
*/
	virtual void Clear() = 0;																//ʂ
/**
*	@brief	ʂ̏FXV܂B
*
*			BaseDrawManager	NX\link	nsAbyssLib::nsDrawManager::BaseDrawManager::SetClearColor	SetClearColor\endlink\bhŐݒ肵Fuۂ́vFɔf܂B
*/
	virtual void UpdateClearColor() = 0;													//ʂ̏Fi݁jXV
/**
*	@brief	uۂ́vʂ̏F擾܂B
*	@return	uۂ́vʂ̏FԂ܂B
*/
	virtual COLORREF GetPresentClearColor() = 0;											//ʂ̏Fi݁j擾
/**
*	@brief	uۂ́vʂ̏Fݒ肵܂B
*	@param	Color	[in]uۂ́vʂ̏Fw肵܂B
*/
	virtual void SetPresentClearColor(COLORREF Color) = 0;									//ʂ̏Fi݁jݒ
/**
*	@brief	摜̒ʏ]iFjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void Blt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
																							//ʏ]iFj
/**
*	@brief	摜̉F]iFjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void AddBlt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
																							//F]iFj
/**
*	@brief	摜̌F]iFjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void SubBlt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
																							//F]iFj
/**
*	@brief	摜̒ʏ]iFȂjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void BltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
																							//ʏ]iFȂj
/**
*	@brief	摜̉F]iFȂjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void AddBltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
																							//F]iFȂj
/**
*	@brief	摜̌F]iFȂjs܂B
*	@param	FileName	[in]摜t@Cw肵܂B
*	@param	x			[in]]̂wWw肵܂B
*	@param	y			[in]]̂xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	SrcRect		[in]]`w肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂BftHgl1.0łB
*	@param	ScalingY	[in]g{iYjw肵܂BftHgl1.0łB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void SubBltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree) = 0;
																							//F]iFȂj
/**
*	@brief	̕`s܂B
*	@param	Text	[in]eLXgw肵܂B
*	@param	x		[in]wWw肵܂B
*	@param	y		[in]xWw肵܂B
*	@param	a		[in]ߓxw肵܂B
*/
	virtual void DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a) = 0;		//`(1)
/**
*	@brief	̕`s܂B
*	@param	Text	[in]eLXgw肵܂B
*	@param	x		[in]wWw肵܂B
*	@param	y		[in]xWw肵܂B
*	@param	a		[in]ߓxw肵܂B
*	@param	Color	[in]J[w肵܂B
*/
	virtual void DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a, COLORREF Color) = 0;
																							//`(2)
/**
*	@brief	̕`s܂B
*	@param	Text		[in]eLXgw肵܂B
*	@param	x			[in]wWw肵܂B
*	@param	y			[in]xWw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Font		[in]tHgw肵܂B
*	@param	Size		[in]TCYw肵܂B
*	@param	Color		[in]J[w肵܂B
*	@param	IsBold		[in]w肵܂B<br>
*						̏ꍇtrueAłȂꍇfalsew肵ĂB
*	@param	IsItalic	[in]Α̂w肵܂B<br>
*						Α̂̏ꍇtrueAłȂꍇfalsew肵ĂB
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void DrawFreeText(const char* Text, int x, int y, BYTE a, const char* Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree) = 0;
																							//`(3)
/**
*	@brief	`̕`s܂B
*	@param	Rect		[in]`w肵܂B
*	@param	Color		[in]`Fw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Degree		[in]]pxw肵܂iPʁFxj@ftHgl0.0łB
*/
	virtual void DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree) = 0;				//``
/**
*	@brief	t`̕`s܂B
*	@param	Rect		[in]`w肵܂B
*	@param	Color		[in]Fw肵܂B
*	@param	a			[in]ߓxw肵܂B
*	@param	Border		[in]g̑w肵܂B
*	@param	BorderColor	[in]g̐Fw肵܂B
*/
	virtual void DrawBorderRect(RECT Rect, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor) = 0;
																							//t``
};

//OtBbNpfoCX̃ANZbT
/**
*	@brief	BaseDrawManager	NXւ̃ANZbTNXłB<br>
*			gpOɁAKSetParent\bhsĂB<br>
*			܂A{NXoR	BaseDrawManager	NX̃vCx[go𑀍삷̂͑ϊ댯ȍsׂłB<br>
*			𗝉A\ӂŎgp悤ɂĂB
*/
class DMAccessor : public IDMAccessor{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DMAccessor(){}																			//ftHgRXgN^

/**
*	@brief	ANZXΏۂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B
*	@param	Parent	[in]ANZXΏۂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	void SetParent(INovelEngine* Parent);													//eGWݒ

	void Clear();																			//ʂ
	void UpdateClearColor();																//ʂ̏Fi݁jXV
	COLORREF GetPresentClearColor();														//ʂ̏Fi݁j擾
	void SetPresentClearColor(COLORREF Color);												//ʂ̏Fi݁jݒ
	void Blt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//ʏ]iFj
	void AddBlt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFj
	void SubBlt(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFj
	void BltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//ʏ]iFȂj
	void AddBltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFȂj
	void SubBltFast(const char* FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//F]iFȂj
	void DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a);					//`(1)
	void DrawFreeText(const TextTokenSection& Text, int x, int y, BYTE a, COLORREF Color);	//`(2)
	void DrawFreeText(const char* Text, int x, int y, BYTE a, const char* Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree = 0.0f);
																							//`(3)
	void DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree = 0.0f);					//``
	void DrawBorderRect(RECT Rect, COLORREF Color, BYTE a, unsigned int Border, COLORREF BorderColor);
																							//t``
private:
	INovelEngine* Outer;																	//eGW̃AhX

	DMAccessor(const DMAccessor&);															//Rs[RXgN^i֎~j
	DMAccessor& operator =(const DMAccessor&);												//Zqi֎~j
};

#ifdef __cplusplus
extern "C"{
#endif

//ANZbT擾/ݒ
/**
*	@brief	IDMAccessor	NX擾܂B
*	@return	IDMAccessor	NXւ̃|C^Ԃ܂B
*/
__declspec(dllexport) IDMAccessor* GetDMAccessor();											//ANZbT擾
/**
*	@brief	IDMAccessor	NXɃANZXΏۂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B
*	@param	Parent	[in]ANZXΏۂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
__declspec(dllexport) void SetDMAccessor(INovelEngine* Parent);								//ANZbTݒ

#ifdef __cplusplus
}
#endif

}
}

#endif