#include "stdafx.h"
#include "index.h"
#include "InputManager.h"

namespace nsAbyssLib{
namespace nsInputManager{

//ftHgRXgN^
BaseInputManager::BaseInputManager(){
	SetGuardTime(0);
}

//ĂяoiǗj
bool BaseInputManager::OnCallBackLog() const{
	int Temp;
	GetZ(Temp);
	return(Temp>0);
}
//Ăяoiݒj
bool BaseInputManager::OnCallConfig() const{
	return(false);
}
//Ăяoij[j
bool BaseInputManager::OnCallMenu() const{
	return(PushMButton());
}
//ĂяoiZ[uj
bool BaseInputManager::OnCallSave() const{
	return(false);
}
//Ăяoi[hj
bool BaseInputManager::OnCallLoad() const{
	return(false);
}
//Ăяoiꎞ~j
bool BaseInputManager::OnCallSuspend() const{
	return(false);
}
//ĂяoiIj
bool BaseInputManager::OnCallEndApp() const{
	return(false);
}
//߂iǗj
bool BaseInputManager::OnReturnBackLog() const{
	return(PushRButton());
}
//߂iݒj
bool BaseInputManager::OnReturnConfig() const{
	return(PushRButton());
}
//߂ij[j
bool BaseInputManager::OnReturnMenu() const{
	return(PushRButton());
}
//߂iZ[uj
bool BaseInputManager::OnReturnSave() const{
	return(PushRButton());
}
//߂i[hj
bool BaseInputManager::OnReturnLoad() const{
	return(PushRButton());
}
//I[gI
bool BaseInputManager::OnAutoOn() const{
	return(false);
}
//I[gIt
bool BaseInputManager::OnAutoOff() const{
	return(PushLButton());
}
//XLbvI
bool BaseInputManager::OnSkipOn() const{
	return(false);
}
//XLbvIt
bool BaseInputManager::OnSkipOff() const{
	return(PushLButton());
}
//eLXgi߂
bool BaseInputManager::OnClickText() const{
	return(PushLButton());
}
//eLXgEChE
bool BaseInputManager::OnEraseTextWindow() const{
	return(PushRButton());
}
//OɎQ
bool BaseInputManager::OnRollUpLog() const{
	int Temp;
	GetZ(Temp);
	return(Temp>0);
}
//OɎQ
bool BaseInputManager::OnRollDownLog() const{
	int Temp;
	GetZ(Temp);
	return(Temp<0);
}
//Iz[h
bool BaseInputManager::OnHoldSelect() const{
	return(LButton());
}
//INbN(1)
bool BaseInputManager::OnPushSelect() const{
	return(PushLButton());
}
//INbN(2)
bool BaseInputManager::OnClickSelect() const{
	return(PushUpLButton());
}
//{^z[h
bool BaseInputManager::OnHoldButton() const{
	return(LButton());
}
//{^NbN(1)
bool BaseInputManager::OnPushButton() const{
	return(PushLButton());
}
//{^NbN(2)
bool BaseInputManager::OnClickButton() const{
	return(PushUpLButton());
}
//UI{^z[h
bool BaseInputManager::OnHoldUIButton() const{
	return(LButton());
}
//UI{^NbN(1)
bool BaseInputManager::OnPushUIButton() const{
	return(PushLButton());
}
//UI{^NbN(2)
bool BaseInputManager::OnClickUIButton() const{
	return(PushUpLButton());
}

//K[h^C
void BaseInputManager::DecGuardTime(){
	if(m_GuardTime>0){
		m_GuardTime--;
	}
}
//K[h^C
bool BaseInputManager::IsGuardTime() const{
	return(m_GuardTime>0);
}
//K[h^Cݒ
void BaseInputManager::SetGuardTime(unsigned int Time){
	m_GuardTime = Time;
}

}
}