/*************************************************
t@CFSimulatedHeap.h
쐬ҁ@@Fт
@@@F[q[v
*************************************************/
/**
*	@file	SimulatedHeap.h
*	@brief	[q[v֌WłB
*/
#ifndef ABYSSLIB_SIMULATEDHEAP_H
#define ABYSSLIB_SIMULATEDHEAP_H

namespace nsAbyssLib{

namespace nsTextStream{
//ˑNXiQƐFTextStream.hj
class ITextStream;
}
namespace nsCommand{
//ˑ\́iQƐFCommand.hj
struct CmdParam;
//ˑNXiQƐFCommand.hj
class ICmd_Base;
}
namespace nsCore{
//ˑNXiQƐFAbyssLib.hj
class INovelEngine;
}

namespace nsSimulatedHeap{

//[q[viC^[tF[Xj
/**
*	@brief	[q[ṽC^[tF[XłB
*
*			[q[vƂ́AAbyssLib̊ep[^̂ƂłB<br>
*			AbyssLibł͖{NXgpāAȉ̃p[^ǗĂ܂B<br>
*			Ex<br>
*			Eϐ<br>
*			EOϐ<br>
*			EV{<br>
*			{NX́Amap<string, int>ɎĂ܂B
*/
class ISingleHeap{
public:
	//
/**
*	@brief	p[^̒l擾܂B
*
*			p[^݂Ȃꍇ́A\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*	@param	Text	[in]p[^̖Ow肵܂B
*	@return	p[^̒lԂ܂B
*/
	virtual int Get(const char* Text) const = 0;							//擾
/**
*	@brief	p[^݂邩擾܂B
*	@param	Text	[in]p[^̖Ow肵܂B
*	@return	p[^݂邩Ԃ܂B<br>
*			݂ꍇtrueA݂ȂꍇfalseԂ܂B
*/
	virtual bool Find(const char* Text) const = 0;							//
/**
*	@brief	p[^̐VK쐬܂͑s܂B
*
*			݂Ȃp[^̏ꍇ͐VK쐬Ãp[^̏ꍇ͑s܂B
*	@param	Text	[in]p[^̖Ow肵܂B
*	@param	Value	[in]p[^̒lw肵܂B
*/
	virtual void Set(const char* Text, int Value) = 0;						//ǉ/ݒ
/**
*	@brief	p[^̖Oƒl̈ꗗo͂܂B
*	@param	Output	[in]\link	nsAbyssLib::nsTextStream::ITextStream	eLXgo̓Xg[\endlinkw肵܂B
*/
	virtual void Print(const ITextStream* Output) const = 0;				//e\
};

//[q[v
/**
*	@brief	[q[vNXłB
*
*			[q[vƂ́AAbyssLib̊ep[^̂ƂłB<br>
*			AbyssLibł͖{NXgpāAȉ̃p[^ǗĂ܂B<br>
*			Ex<br>
*			Eϐ<br>
*			EOϐ<br>
*			EV{<br>
*			{NX́Amap<string, int>ɎĂ܂B
*/
class SingleHeap : public ISingleHeap{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	SingleHeap(){}															//ftHgRXgN^

/**
*	@brief	Sp[^NA܂B
*/
	void Clear();															//
	int Get(const char* Text) const;										//擾
	bool Find(const char* Text) const;										//
	void Set(const char* Text, int Value);									//ǉ/ݒ
	void Print(const ITextStream* Output) const;							//e\

/**
*	@brief	p[^̎́imap<string, int>jւ̃|C^擾܂B
*	@return	p[^̎́imap<string, int>jւ̃|C^Ԃ܂B
*/
	map<string, int>* GetObj();												//̂擾(1)
/**
*	@brief	p[^̎́imap<string, int>jւ̃|C^擾܂B
*	@return	p[^̎́imap<string, int>jւ̃|C^Ԃ܂B
*/
	const map<string, int>* GetObj() const;									//̂擾(2)

/**
*	@brief	p[^̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void Save(IIOStream* IOStream);											//ۑ
/**
*	@brief	p[^̓ǂݍ݂s܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void Load(IIOStream* IOStream);											//ǂݍ
private:
	map<string, int> m_Heap;												//[q[v

	SingleHeap(const SingleHeap&);											//Rs[RXgN^i֎~j
	SingleHeap& operator =(const SingleHeap&);								//Zqi֎~j
};

//[q[vi߁jiC^[tF[Xj
/**
*	@brief	XNvg߂̋[q[ṽC^[tF[XłB
*
*			[q[vƂ́AAbyssLib̊ep[^̂ƂłB<br>
*			AbyssLibł͖{NXgpāAȉ̃p[^ǗĂ܂B<br>
*			EXNvg
*/
class ICommandHeap{
public:
	//i߃Xgj
/**
*	@brief	XNvg߃Xgo͂܂B
*	@param	Output	[in]\link	nsAbyssLib::nsTextStream::ITextStream	eLXgo̓Xg[\endlinkw肵܂B
*/
	virtual void Print(const ITextStream* Output) const = 0;				//߂̓e\
	//iCe[^j
/**
*	@brief	XNvg߂̃Ce[^擾܂B
*
*			Ce[^Ƃ́AXNvg߂̎sʒûƂłB<br>
*			X^bN\ɂȂĂAGOSUB`RETURN̐\ɑΉĂ܂B<br>
*			Ce[^ɋő݂Ȃꍇ́A\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*	@return	XNvg߂̃Ce[^Ԃ܂B
*/
	virtual int GetIterator() const = 0;									//Ce[^擾
/**
*	@brief	XNvg߂̃Ce[^Z܂B
*
*			Ce[^Ƃ́AXNvg߂̎sʒûƂłB<br>
*			X^bN\ɂȂĂAGOSUB`RETURN̐\ɑΉĂ܂B<br>
*			Ce[^ɋő݂Ȃꍇ́A\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*	@param	it	[in]Zlw肵܂B
*/
	virtual void AddIterator(int it) = 0;									//Ce[^Z
/**
*	@brief	XNvg߂̃Ce[^ݒ肵܂B
*
*			Ce[^Ƃ́AXNvg߂̎sʒûƂłB<br>
*			X^bN\ɂȂĂAGOSUB`RETURN̐\ɑΉĂ܂B<br>
*			Ce[^ɋő݂Ȃꍇ́A\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*	@param	it	[in]ݒlw肵܂B
*/
	virtual void SetIterator(int it) = 0;									//Ce[^ݒ
/**
*	@brief	XNvg߂̃Ce[^|bv܂B
*
*			Ce[^Ƃ́AXNvg߂̎sʒûƂłB<br>
*			X^bN\ɂȂĂAGOSUB`RETURN̐\ɑΉĂ܂B<br>
*			Ce[^ɋő݂Ȃꍇ́A\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*/
	virtual void PopIterator() = 0;											//Ce[^|bv
/**
*	@brief	XNvg߂̃Ce[^vbV܂B
*
*			Ce[^Ƃ́AXNvg߂̎sʒûƂłB<br>
*			X^bN\ɂȂĂAGOSUB`RETURN̐\ɑΉĂ܂B
*	@param	it	[in]vbVlw肵܂B
*/
	virtual void PushIterator(int it) = 0;									//Ce[^vbV
/**
*	@brief	XNvg߂̃Ce[^̃Xgo͂܂B
*	@param	Output	[in]\link	nsAbyssLib::nsTextStream::ITextStream	eLXgo̓Xg[\endlinkw肵܂B
*/
	virtual void PrintIterator(const ITextStream* Output) const = 0;		//Ce[^̓e\
};

//[q[vi߁j
/**
*	@brief	XNvg߂̋[q[vNXłB
*
*			[q[vƂ́AAbyssLib̊ep[^̂ƂłB<br>
*			AbyssLibł͖{NXgpāAȉ̃p[^ǗĂ܂B<br>
*			EXNvg
*/
class CommandHeap : public ICommandHeap{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	CommandHeap();															//ftHgRXgN^
/**
*	@brief	fXgN^łB
*/
	~CommandHeap();															//fXgN^

/**
*	@brief	s܂B
*/
	void Initialize();														//

/**
*	@brief	eGWݒ肵܂B
*
*			{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B<br>
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	void SetParent(INovelEngine* Parent);									//eGWݒ

/**
*	@brief	XNvg߂s܂B
*
*			߃Xg܂̓Ce[^݂ȂꍇCe[^sȈʒuwĂꍇ\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B<br>
*			P̎sŃCe[^w\link	nsAbyssLib::nsCommand::ICmd_Base	߃NX\endlinkRun\bhPĂяo܂B<br>
*			āA[v\̒ŌJԂĂяoKv܂B
*/
	void Run();																//߂s
/**
*	@brief	XNvg߃XgNA܂B
*/
	void Clear();															//߃Xg
	void Print(const ITextStream* Output) const;							//߂̓e\
/**
*	@brief	XNvg߃XgɃXNvg߂VKǉ܂B
*	@param	NewCommand	[in]VKǉ\link	nsAbyssLib::nsCommand::ICmd_Base	߃NX\endlinkw肵܂B
*	@param	Parameter	[in]VKǉ\link	nsAbyssLib::nsCommand::ICmd_Base	߃NX\endlinkɈnp[^w肵܂B
*/
	void Add(ICmd_Base* NewCommand, const CmdParam& Parameter);				//߂VKɒǉ

/**
*	@brief	XNvg߃Xg̎́ivector<ICmd_Base*>jւ̃|C^擾܂B
*	@return	XNvg߃Xg̎́ivector<ICmd_Base*>jւ̃|C^Ԃ܂B
*/
	vector<ICmd_Base*>* GetObj();											//̂擾(1)
/**
*	@brief	XNvg߃Xg̎́ivector<ICmd_Base*>jւ̃|C^擾܂B
*	@return	XNvg߃Xg̎́ivector<ICmd_Base*>jւ̃|C^Ԃ܂B
*/
	const vector<ICmd_Base*>* GetObj() const;								//̂擾(2)

/**
*	@brief	XNvg߃Xg̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void Save(IIOStream* IOStream);											//ۑ
/**
*	@brief	XNvg߃Xg̓ǂݍ݂s܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void Load(IIOStream* IOStream);											//ǂݍ

	int GetIterator() const;												//Ce[^擾
	void AddIterator(int it);												//Ce[^Z
	void SetIterator(int it);												//Ce[^ݒ
	void PopIterator();														//Ce[^|bv
/**
*	@brief	XNvg߂̃Ce[^NA܂B
*/
	void ClearIterator();													//Ce[^S
	void PushIterator(int it);												//Ce[^vbV
	void PrintIterator(const ITextStream* Output) const;					//Ce[^̓e\

/**
*	@brief	XNvg߂̃Ce[^̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void SaveIterator(IIOStream* IOStream);									//Ce[^ۑ
/**
*	@brief	XNvg߂̃Ce[^̓ǂݍ݂s܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void LoadIterator(IIOStream* IOStream);									//Ce[^ǂݍ
private:
	INovelEngine* Outer;													//eGW̃AhX
	vector<int> m_Iterator;													//Ce[^i߁j
	vector<ICmd_Base*> m_Heap;												//[q[vi߁j

	CommandHeap(const CommandHeap&);										//Rs[RXgN^i֎~j
	CommandHeap& operator =(const CommandHeap&);							//Zqi֎~j
};

}
}

#endif