/*************************************************
t@CFPlugins.h
쐬ҁ@@Fт
@@@FvOC̊Ǘ
*************************************************/
/**
*	@file	Plugins.h
*	@brief	vOC̊Ǘ֌WłB
*
*			RegisterP`֐ŗlXȂ̂o^邱ƂɂAAbyssLibOg邱Ƃ\łB
*/
#ifndef ABYSSLIB_PLUGINS_H
#define ABYSSLIB_PLUGINS_H

namespace nsAbyssLib{

namespace nsCore{
//ˑNXiQƐFAbyssLib.hj
class INovelEngine;
}
namespace nsCommand{
//ˑNXiQƐFCommand.hj
class ICmd_Base;
}

namespace nsPlugins{

//^`
/**
*	@brief	߃NXFactory֐̌^`łB
*/
typedef ICmd_Base* (*FactoryFunc)();
/**
*	@brief	ʍXV֐̌^`łB
*/
typedef void (*UpdateFunc)(INovelEngine*);
/**
*	@brief	ʌʊ֐̌^`łB
*/
typedef void (*EffectFunc)(INovelEngine*);
/**
*	@brief	\͊֐̌^`łB
*/
typedef int (*AnalysisFunc)(unsigned int);
/**
*	@brief	[Jݒۑ֐̌^`łB
*/
typedef void (*SaveLocalDataFunc)(INovelEngine*, IIOStream*);
/**
*	@brief	[Jݒǂݍ݊֐̌^`łB
*/
typedef void (*LoadLocalDataFunc)(INovelEngine*, IIOStream*);
/**
*	@brief	ݒۑ֐̌^`łB
*/
typedef void (*SaveEnvironmentDataFunc)(INovelEngine*, IIOStream*);
/**
*	@brief	ݒǂݍ݊֐̌^`łB
*/
typedef void (*LoadEnvironmentDataFunc)(INovelEngine*, IIOStream*);
/**
*	@brief	`^XNǉ֐̌^`łB
*/
typedef void (*AddDrawTaskFunc)(INovelEngine*, const DrawTask&);
/**
*	@brief	`^XN֐̌^`łB
*/
typedef void (*DrawTaskFunc)(INovelEngine*, const DrawTask&);
/**
*	@brief	`֐̌^`łB
*/
typedef void (*BltFunc)(INovelEngine*, const DrawTask&);
//vOCpo^}bvi񋓌^Factory֐j
/**
*	@brief	vOCȂǂ擾߃NXFactory֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPFactory	RegisterPFactory\endlink֐Ŗ߃NXFactory֐o^邱ƂŖ߂̊g\łB
*/
extern map<unsigned int, FactoryFunc> PFactory;
//vOCpo^}bvi񋓌^Update֐j
/**
*	@brief	vOCȂǂ擾ʍXV֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPUpdate	RegisterPUpdate\endlink֐ŉʍXV֐o^邱ƂŉʍXV̊g\łB
*/
extern map<unsigned int, UpdateFunc> PUpdate;
//vOCpo^}bvi񋓌^Effect֐j
/**
*	@brief	vOCȂǂ擾ʌʊ֐ie`Oj̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPEffect1	RegisterPEffect1\endlink֐ŉʌʊ֐o^邱Ƃŉʌʂ̊g\łB
*/
extern map<unsigned int, EffectFunc> PEffect1;
/**
*	@brief	vOCȂǂ擾ʌʊ֐ieLXgEChE`Oj̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPEffect2	RegisterPEffect2\endlink֐ŉʌʊ֐o^邱Ƃŉʌʂ̊g\łB
*/
extern map<unsigned int, EffectFunc> PEffect2;
/**
*	@brief	vOCȂǂ擾ʌʊ֐ieLXgEChE`j̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPEffect3	RegisterPEffect3\endlink֐ŉʌʊ֐o^邱Ƃŉʌʂ̊g\łB
*/
extern map<unsigned int, EffectFunc> PEffect3;
//vOCpo^}bvi񋓌^Analysis֐AʎqƗ񋓌^j
/**
*	@brief	vOCȂǂ擾\͊֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPAnalysis	RegisterPAnalysis\endlink֐ō\͊֐o^邱ƂŖ߂̊g\łB
*/
extern map<unsigned int, AnalysisFunc> PAnalysis;
/**
*	@brief	vOCȂǂ擾߂̎ʎq̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPCommandName	RegisterPCommandName\endlink֐Ŏʎqo^邱ƂŖ߂̊g\łB
*/
extern map<string, unsigned int> PCommandName;
//vOCpo^Xgi񋓌^j
/**
*	@brief	vOCȂǂ擾rsȂ߂̓o^XgłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPEnableSystemCommand	RegisterPEnableSystemCommand\endlink֐ŔrsȂ߂o^邱ƂŖ߂̊g\łB<br>
*			rsi{o^Xgɖ߂o^Ȃj߂́Aȉ̂悤ɓ삵܂B<br>
*			Eߎs͊Ǘ⃁j[̌ĂяoȂǂƂu߈ȊÔƁv؍sȂȂ܂
*/
extern vector<unsigned int> PEnableSystemCommand;
//vOCpo^}bvivOCƃ[Jf[^̕ۑ֐j
/**
*	@brief	vOCȂǂ擾[Jf[^̕ۑ֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPSaveLocalDataFunc	RegisterPSaveLocalDataFunc\endlink֐Ń[Jf[^̕ۑ֐o^邱ƂŃZ[uf[^̊g\łB
*/
extern map<string, SaveLocalDataFunc> PSaveLocalDataFunc;
//vOCpo^}bvivOCƃ[Jf[^̓ǂݍ݊֐j
/**
*	@brief	vOCȂǂ擾[Jf[^̓ǂݍ݊֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPLoadLocalDataFunc	RegisterPLoadLocalDataFunc\endlink֐Ń[Jf[^̓ǂݍ݊֐o^邱ƂŃZ[uf[^̊g\łB
*/
extern map<string, LoadLocalDataFunc> PLoadLocalDataFunc;
//vOCpo^}bvivOCƊݒ̕ۑ֐j
/**
*	@brief	vOCȂǂ擾ݒ̕ۑ֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPSaveEnvironmentDataFunc	RegisterPSaveEnvironmentDataFunc\endlink֐Ŋݒ̕ۑ֐o^邱ƂŃZ[uf[^̊g\łB
*/
extern map<string, SaveEnvironmentDataFunc> PSaveEnvironmentDataFunc;
//vOCpo^}bvivOCƊݒ̓ǂݍ݊֐j
/**
*	@brief	vOCȂǂ擾ݒ̓ǂݍ݊֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPLoadEnvironmentDataFunc	RegisterPLoadEnvironmentDataFunc\endlink֐Ŋݒ̓ǂݍ݊֐o^邱ƂŃZ[uf[^̊g\łB
*/
extern map<string, LoadEnvironmentDataFunc> PLoadEnvironmentDataFunc;
//vOCpo^}bvi񋓌^ƕ`^XNǉ֐j
/**
*	@brief	vOCȂǂ擾`^XN̒ǉ֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPAddDrawTaskFunc	RegisterPAddDrawTaskFunc\endlink֐ŕ`^XN̒ǉ֐o^邱Ƃŕ`^XN̊g\łB
*/
extern map<unsigned int, AddDrawTaskFunc> PAddDrawTaskFunc;
//vOCpo^}bvi񋓌^ƕ`^XN֐j
/**
*	@brief	vOCȂǂ擾`^XN̏֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPDrawTaskFunc	RegisterPDrawTaskFunc\endlink֐ŕ`^XN̏֐o^邱Ƃŕ`^XN̊g\łB
*/
extern map<unsigned int, DrawTaskFunc> PDrawTaskFunc;
//vOCpo^}bvi񋓌^ƕ`֐j
/**
*	@brief	vOCȂǂ擾`֐̓o^}bvłB
*
*			\link	nsAbyssLib::nsPlugins::RegisterPBltFunc	RegisterPBltFunc\endlink֐ŕ`֐o^邱Ƃŕ`^XN̊g\łB
*/
extern map<unsigned int, BltFunc> PBltFunc;

//vOCLoad/Free
/**
*	@brief	vOCǂݍ݂܂B
*
*			tH_ɑ݂DLL𒀈`FbNAvOCłꍇ͓ǂݍ݂܂B
*/
void LoadPlugin();
/**
*	@brief	ǂݍ񂾃vOC܂B
*
*			vOIɕKĂяo悤ɂĂB<br>
*			܂A{֐ĂяoOɕKSĂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkɑ΂FreeCommand֐Ăяo悤ɂĂB
*/
void FreePlugin();
/**
*	@brief	SĂ̖߃NX܂B
*
*			vOIɕKĂяo悤ɂĂB<br>
*			FreePlugin֐ĂяoOɕKSĂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkɑ΂Ė{֐ĂяoĂB
*	@param	Outer	[in]S߃NX̑ΏۂƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
void FreeCommand(INovelEngine* Outer);

#ifdef __cplusplus
extern "C"{
#endif

//o[W擾
/**
*	@brief	AbyssLib̃o[W擾܂B
*	@return	AbyssLib̃o[WԂ܂B
*/
__declspec(dllexport) int GetAbyssLibVersion();

//vOCpo^֐
/**
*	@brief	߃NXFactory֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ߃NXFactory֐́A߃NXɌĂяo܂B
*	@param	PID		[in]߃NXɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]߃NXFactory֐w肵܂B
*/
__declspec(dllexport) void RegisterPFactory(unsigned int PID, FactoryFunc PFunc);
/**
*	@brief	ʍXV֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽʍXV֐́AʍXVɌĂяo܂B
*	@param	PID		[in]ʍXVp^[ɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]ʍXV֐w肵܂B
*/
__declspec(dllexport) void RegisterPUpdate(unsigned int PID, UpdateFunc PFunc);
/**
*	@brief	ʌʁie`Oj֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽʌʊ֐́Aʌʁie`OjɌĂяo܂B
*	@param	PID		[in]ʌʁie`Ojp^[ɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]ʌʁie`Oj֐w肵܂B
*/
__declspec(dllexport) void RegisterPEffect1(unsigned int PID, EffectFunc PFunc);
/**
*	@brief	ʌʁieLXgEChE`Oj֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽʌʊ֐́AʌʁieLXgEChE`OjɌĂяo܂B
*	@param	PID		[in]ʌʁieLXgEChE`Ojp^[ɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]ʌʁieLXgEChE`Oj֐w肵܂B
*/
__declspec(dllexport) void RegisterPEffect2(unsigned int PID, EffectFunc PFunc);
/**
*	@brief	ʌʁieLXgEChE`j֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽʌʊ֐́AʌʁieLXgEChE`jɌĂяo܂B
*	@param	PID		[in]ʌʁieLXgEChE`jp^[ɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]ʌʁieLXgEChE`j֐w肵܂B
*/
__declspec(dllexport) void RegisterPEffect3(unsigned int PID, EffectFunc PFunc);
/**
*	@brief	\͊֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ\͊֐́A\͎ɌĂяo܂B
*	@param	PID		[in]߃NXɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]\͊֐w肵܂B
*/
__declspec(dllexport) void RegisterPAnalysis(unsigned int PID, AnalysisFunc PFunc);
/**
*	@brief	ʎqo^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽʎq́A\͎ɎQƂ܂B
*	@param	PName	[in]ʎqw肵܂B
*	@param	PID		[in]߃NXɑΉӂ̒lw肵܂B
*/
__declspec(dllexport) void RegisterPCommandName(const char* PName, unsigned int PID);
/**
*	@brief	rsȂ߂o^Xgɓo^܂B
*
*			{֐ɂēo^Xgɓo^ꂽrsȂ߂́A߃NXsOŎQƂ܂B
*	@param	PID		[in]߃NXɑΉӂ̒lw肵܂B
*/
__declspec(dllexport) void RegisterPEnableSystemCommand(unsigned int PID);
/**
*	@brief	[Jf[^̕ۑ֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ[Jf[^̕ۑ֐́A[Jf[^̕ۑɌĂяo܂B
*	@param	PName	[in]vOCw肵܂B
*	@param	PFunc	[in][Jf[^̕ۑ֐w肵܂B
*/
__declspec(dllexport) void RegisterPSaveLocalDataFunc(const char* PName, SaveLocalDataFunc PFunc);
/**
*	@brief	[Jf[^̓ǂݍ݊֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ[Jf[^̓ǂݍ݊֐́A[Jf[^̓ǂݍݎɌĂяo܂B
*	@param	PName	[in]vOCw肵܂B
*	@param	PFunc	[in][Jf[^̓ǂݍ݊֐w肵܂B
*/
__declspec(dllexport) void RegisterPLoadLocalDataFunc(const char* PName, LoadLocalDataFunc PFunc);
/**
*	@brief	ݒ̕ۑ֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽݒ̕ۑ֐́Aݒ̕ۑɌĂяo܂B
*	@param	PName	[in]vOCw肵܂B
*	@param	PFunc	[in]ݒ̕ۑ֐w肵܂B
*/
__declspec(dllexport) void RegisterPSaveEnvironmentDataFunc(const char* PName, SaveEnvironmentDataFunc PFunc);
/**
*	@brief	ݒ̓ǂݍ݊֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽݒ̓ǂݍ݊֐́Aݒ̓ǂݍݎɌĂяo܂B
*	@param	PName	[in]vOCw肵܂B
*	@param	PFunc	[in]ݒ̓ǂݍ݊֐w肵܂B
*/
__declspec(dllexport) void RegisterPLoadEnvironmentDataFunc(const char* PName, LoadEnvironmentDataFunc PFunc);
/**
*	@brief	`^XNǉ֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ`^XNǉ֐́A`^XNǉɌĂяo܂B
*	@param	PID		[in]`^XNɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]`^XNǉ֐w肵܂B
*/
__declspec(dllexport) void RegisterPAddDrawTaskFunc(unsigned int PID, AddDrawTaskFunc PFunc);
/**
*	@brief	`^XN֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ`^XN֐́A`^XN`掞ɌĂяo܂B
*	@param	PID		[in]`^XNɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]`^XN֐w肵܂B
*/
__declspec(dllexport) void RegisterPDrawTaskFunc(unsigned int PID, DrawTaskFunc PFunc);
/**
*	@brief	`֐o^}bvɓo^܂B
*
*			{֐ɂēo^}bvɓo^ꂽ`֐́A`掞ɌĂяo܂B
*	@param	PID		[in]`@ɑΉӂ̒lw肵܂B
*	@param	PFunc	[in]`֐w肵܂B
*/
__declspec(dllexport) void RegisterPBltFunc(unsigned int PID, BltFunc PFunc);

#ifdef __cplusplus
}
#endif

}
}

#endif