/*************************************************
t@CFScene.h
쐬ҁ@@Fт
@@@FeV[
*************************************************/
/**
*	@file	Scene.h
*	@brief	eV[֌WłB
*/
#ifndef ABYSSLIB_SCENE_H
#define ABYSSLIB_SCENE_H

namespace nsAbyssLib{
namespace nsScene{

//V[NXiC^[tF[Xj
/**
*	@brief	V[NX̃C^[tF[XłB
*
*			AbyssLibł͒ʏʁAǗʁAZ[uʁA[hʁAݒʁAj[ʂV[NXŎĂ܂B<br>
*			āA{C^[tF[XpĎ邱ƂŃ[U[C^[tF[XCӂ̂̂ɕύX邱Ƃ\łB
*/
class IScene_Base{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~IScene_Base(){}										//zfXgN^

/**
*	@brief	s܂B
*
*			s悤ɎĂB
*/
	virtual void Initialize() = 0;									//

/**
*	@brief	Os܂B
*
*			Os悤ɎĂB
*/
	virtual void OnBegin() = 0;										//O
/**
*	@brief	{s܂B
*
*			{s悤ɎĂB
*/
	virtual void OnMove() = 0;										//{
/**
*	@brief	`s܂B
*
*			`s悤ɎĂB
*/
	virtual void OnDraw() = 0;										//`
/**
*	@brief	㏈s܂B
*
*			㏈s悤ɎĂB
*/
	virtual void OnEnd() = 0;										//㏈

/**
*	@brief	eGWݒ肵܂B
*
*			{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkݒ肵܂B<br>
*	@param	Parent	[in]{NX̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkw肵܂B
*/
	virtual void SetParent(NovelPlayer* Parent){					//eGWݒ
		Outer = Parent;
	}
protected:
/**
*	@brief	߂̐eƂȂ\link	nsAbyssLib::nsCore::INovelEngine	mxGWNX\endlinkւ̃|C^łB<br>
*
*			{oϐėlXȑsƂ\łB
*/
	NovelPlayer* Outer;												//eGW̃AhX
};

//ʏV[iftHgj
/**
*	@brief	AbyssLibftHg̒ʏV[łB
*/
class DefaultNormalScene : public IScene_Base{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DefaultNormalScene();											//ftHgRXgN^

	void Initialize();												//

	void OnBegin();													//O
	void OnMove();													//{
	void OnDraw();													//`
	void OnEnd();													//㏈
private:
	bool m_IsRun;													//XNvgsԂH

	DefaultNormalScene(const DefaultNormalScene&);					//Rs[RXgN^i֎~j
	DefaultNormalScene& operator =(const DefaultNormalScene&);		//Zqi֎~j
};

//ǗV[iftHgj
/**
*	@brief	AbyssLibftHg̊ǗV[łB
*/
class DefaultBackLogScene : public IScene_Base{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DefaultBackLogScene();											//ftHgRXgN^

	void Initialize();												//

	void OnBegin();													//O
	void OnMove();													//{
	void OnDraw();													//`
	void OnEnd();													//㏈
private:
	bool m_IsFirst;													//tO
	Record m_Temp;													//ޔp

	DefaultBackLogScene(const DefaultBackLogScene&);				//Rs[RXgN^i֎~j
	DefaultBackLogScene& operator =(const DefaultBackLogScene&);	//Zqi֎~j
};

//Z[uV[iftHgj
/**
*	@brief	AbyssLibftHg̃Z[uV[łB
*/
class DefaultSaveScene : public IScene_Base{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DefaultSaveScene();												//ftHgRXgN^
/**
*	@brief	RXgN^łB
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	DefaultSaveScene(IIOStream* IOStream);							//RXgN^if[^o̓NXwj
/**
*	@brief	fXgN^łB
*/
	~DefaultSaveScene();											//fXgN^

	void Initialize();												//

	void OnBegin();													//O
	void OnMove();													//{
	void OnDraw();													//`
	void OnEnd();													//㏈

	void SetParent(NovelPlayer* Parent);							//eGWݒ
private:
	unsigned int m_nSelect;											//Iԍi\̈ʁj
	UICButtonDraw m_Data[10];										//{^if[^j
	UICButtonDraw m_Select[10];										//{^i\̈ʁj
	UICButtonDraw m_EndSave;										//{^iZ[uIj
	IIOStream* m_IOStream;											//f[^o̓NX
	virtual bool Confirm();											//mF
	virtual const char* GetSaveFileName(unsigned int Num);			//Z[ut@C擾
	virtual void SetData(unsigned int Num);							//{^if[^jݒ

	DefaultSaveScene(const DefaultSaveScene&);						//Rs[RXgN^i֎~j
	DefaultSaveScene& operator =(const DefaultSaveScene&);			//Zqi֎~j
};

//[hV[iftHgj
/**
*	@brief	AbyssLibftHg̃[hV[łB
*/
class DefaultLoadScene : public IScene_Base{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DefaultLoadScene();												//ftHgRXgN^
/**
*	@brief	RXgN^łB
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	DefaultLoadScene(IIOStream* IOStream);							//RXgN^if[^o̓NXwj
/**
*	@brief	fXgN^łB
*/
	~DefaultLoadScene();											//fXgN^

	void Initialize();												//

	void OnBegin();													//O
	void OnMove();													//{
	void OnDraw();													//`
	void OnEnd();													//㏈

	void SetParent(NovelPlayer* Parent);							//eGWݒ
private:
	unsigned int m_nSelect;											//Iԍi\̈ʁj
	UICButtonDraw m_Data[10];										//{^if[^j
	UICButtonDraw m_Select[10];										//{^i\̈ʁj
	UICButtonDraw m_EndLoad;										//{^i[hIj
	IIOStream* m_IOStream;											//f[^o̓NX
	virtual bool Confirm();											//mF
	virtual const char* GetSaveFileName(unsigned int Num);			//Z[ut@C擾
	virtual void SetData(unsigned int Num);							//{^if[^jݒ

	DefaultLoadScene(const DefaultLoadScene&);						//Rs[RXgN^i֎~j
	DefaultLoadScene& operator =(const DefaultLoadScene&);			//Zqi֎~j
};

//ݒV[iftHgj
/**
*	@brief	AbyssLibftHg̊ݒV[łB
*/
class DefaultConfigScene : public IScene_Base{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DefaultConfigScene();											//ftHgRXgN^

	void Initialize();												//

	void OnBegin();													//O
	void OnMove();													//{
	void OnDraw();													//`
	void OnEnd();													//㏈

	void SetParent(NovelPlayer* Parent);							//eGWݒ
private:
	UICBarDraw m_AutoModeTime;										//o[iI[g[h̑ҋ@ԁj
	UICBarDraw m_DefaultTextSpeed;									//o[ieLXg̕\xiftHgjj
	UICBarDraw m_DefaultBGMVolume;									//o[iBGM̉ʁiftHgjj
	UICBarDraw m_DefaultSEVolume;									//o[iSẺʁiftHgjj
	UICBarDraw m_DefaultVoiceVolume;								//o[ỉʁiftHgjj
	UICButtonDraw m_WindowMode;										//{^iEChEj
	UICButtonDraw m_FullScreen;										//{^itXN[j
	UICButtonDraw m_ForceSkipOn;									//{^iXLbvj
	UICButtonDraw m_ForceSkipOff;									//{^iXLbvȂj
	UICButtonDraw m_EndConfig;										//{^iݒIj
	virtual void SetAutoModeTime();									//I[g[h̑ҋ@Ԃݒ
	virtual void SetDefaultTextSpeed();								//eLXg̕\xiftHgjݒ
	virtual void SetDefaultBGMVolume();								//BGM̉ʁiftHgjݒ
	virtual void SetDefaultSEVolume();								//SẺʁiftHgjݒ
	virtual void SetDefaultVoiceVolume();							//̉ʁiftHgjݒ
	virtual void UpdateAllBarRate();								//SẴo[̊ꊇݒ

	DefaultConfigScene(const DefaultConfigScene&);					//Rs[RXgN^i֎~j
	DefaultConfigScene& operator =(const DefaultConfigScene&);		//Zqi֎~j
};

//j[V[iftHgj
/**
*	@brief	AbyssLibftHg̃j[V[łB
*/
class DefaultMenuScene : public IScene_Base{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DefaultMenuScene();												//ftHgRXgN^

	void Initialize();												//

	void OnBegin();													//O
	void OnMove();													//{
	void OnDraw();													//`
	void OnEnd();													//㏈

	void SetParent(NovelPlayer* Parent);							//eGWݒ
private:
	UICButtonDraw m_Auto;											//{^iI[g[hj
	UICButtonDraw m_Skip;											//{^iXLbvj
	UICButtonDraw m_Save;											//{^iZ[uj
	UICButtonDraw m_Load;											//{^i[hj
	UICButtonDraw m_Config;											//{^iݒj
	UICButtonDraw m_EndGame;										//{^iQ[Ij
	UICButtonDraw m_EndMenu;										//{^ij[Ij
	virtual bool Confirm();											//mF

	DefaultMenuScene(const DefaultMenuScene&);						//Rs[RXgN^i֎~j
	DefaultMenuScene& operator =(const DefaultMenuScene&);			//Zqi֎~j
};

}
}

#endif