/*************************************************
t@CFTextManager.h
쐬ҁ@@Fт
@@@FǗ̊Ǘ
*************************************************/
/**
*	@file	TextManager.h
*	@brief	Ǘ̊Ǘ֌WłB
*/
#ifndef ABYSSLIB_TEXTMANAGER_H
#define ABYSSLIB_TEXTMANAGER_H

namespace nsAbyssLib{
namespace nsTextManager{

//f[^
/**
*	@brief	f[^\̂łB
*/
struct Record{
/**
*	@brief	f[^̃eLXgłB
*/
	TextTokenSection Text;
/**
*	@brief	f[^̔ҖłB
*/
	TextTokenSection Talker;
/**
*	@brief	f[^̉t@CłB
*/
	vector_mystr VoiceFileName;

/**
*	@brief	ftHgRXgN^łB
*/
	Record(){
		Clear();
	}
/**
*	@brief	oϐ̃NAs܂B
*/
	void Clear(){
		Text.clear();
		Talker.clear();
		VoiceFileName.clear();
	}
};

//ǗǗiC^[tF[Xj
/**
*	@brief	ǗǗNX̃C^[tF[XłB
*
*			{NX͑SĂ̊ǗǗs܂B<br>
*			SĂ̊ǗǗs悤ɎĂB
*/
class ITextManager{
public:
	//XLbv
/**
*	@brief	XLbv邩擾܂B
*	@return	XLbv邩Ԃ܂B<br>
*			XLbvꍇtrueAȂꍇfalseԂ܂B
*/
	virtual bool GetSkip() const = 0;								//XLbv擾
/**
*	@brief	XLbv邩ݒ肵܂B
*	@param	IsSkip	[in]XLbv邩w肵܂B<br>
*					XLbvꍇtrueAȂꍇfalsew肵܂B
*/
	virtual void SetSkip(bool IsSkip) = 0;							//XLbvݒ
	//XLbv
/**
*	@brief	XLbv邩擾܂B
*
*			XLbvƂ́AǃeLXgǂݔ΂XLbv̂ƂłB
*	@return	XLbv邩Ԃ܂B<br>
*			XLbvꍇtrueAȂꍇfalseԂ܂B
*/
	virtual bool GetForceSkip() const = 0;							//XLbv擾
/**
*	@brief	XLbv邩ݒ肵܂B
*
*			XLbvƂ́AǃeLXgǂݔ΂XLbv̂ƂłB
*	@param	IsForceSkip	[in]XLbv邩w肵܂B<br>
*						XLbvꍇtrueAȂꍇfalsew肵܂B
*/
	virtual void SetForceSkip(bool IsForceSkip) = 0;				//XLbvݒ
	//I[g[h̗L
/**
*	@brief	I[g[h擾܂B
*
*			I[g[hƂ́A}EXNbNȂǂƂeLXgœǂݐi߂Ԃ̂ƂłB
*	@return	I[g[hԂ܂B<br>
*			I[g[h̏ꍇtrueAłȂꍇfalseԂ܂B
*/
	virtual bool GetAutoMode() const = 0;							//I[g[h̗L擾
/**
*	@brief	I[g[hݒ肵܂B
*
*			I[g[hƂ́A}EXNbNȂǂƂeLXgœǂݐi߂Ԃ̂ƂłB
*	@param	IsAutoMode	[in]I[g[hw肵܂B<br>
*						I[g[hɂꍇtrueAȂꍇfalsew肵܂B
*/
	virtual void SetAutoMode(bool IsAutoMode) = 0;					//I[g[h̗Lݒ
	//I[g[h̑ҋ@
/**
*	@brief	I[g[h̑ҋ@Ԃ擾܂B
*	@return	I[g[h̑ҋ@ԂԂ܂iPʁF~bj
*/
	virtual unsigned int GetAutoModeTime() const = 0;				//I[g[h̑ҋ@Ԃ擾
/**
*	@brief	I[g[h̑ҋ@Ԃݒ肵܂B
*	@param	Time	[in]I[g[h̑ҋ@Ԃw肵܂iPʁF~bj
*/
	virtual void SetAutoModeTime(unsigned int Time) = 0;			//I[g[h̑ҋ@Ԃݒ
	//O̍őێ
/**
*	@brief	O̍őێ擾܂B
*
*			O̐őێ𒴉߂ꍇAÂO玩ō폜Ă܂B
*	@return	O̍őێԂ܂B
*/
	virtual unsigned int GetKidokuMaxLog() const = 0;				//O̍őێ擾
/**
*	@brief	O̍őێݒ肵܂B
*
*			O̐őێ𒴉߂ꍇAÂO玩ō폜Ă܂B
*	@param	NumMaxLog	[in]O̍őێw肵܂B
*/
	virtual void SetKidokuMaxLog(unsigned int NumMaxLog) = 0;		//O̍őێݒ
	//ǋL^
/**
*	@brief	ǗɋL^ǉ܂B
*	@param	Iterator	[in]ǉL^̃XNvg߂̃Ce[^w肵܂B
*						{Iɂ\link	nsAbyssLib::nsSimulatedHeap::ICommandHeap ICommandHeap\endlinkNX
*						\link	nsAbyssLib::nsSimulatedHeap::ICommandHeap::GetIterator GetIterator\endlink\bhw肵ĂB
*/
	virtual void AddRecord(unsigned int Iterator) = 0;				//L^ɒǉ
/**
*	@brief	ǗɋL^݂邩擾܂B
*	@param	Iterator	[in]݂邩擾L^̃XNvg߂̃Ce[^w肵܂B
*						{Iɂ\link	nsAbyssLib::nsSimulatedHeap::ICommandHeap ICommandHeap\endlinkNX
*						\link	nsAbyssLib::nsSimulatedHeap::ICommandHeap::GetIterator GetIterator\endlink\bhw肵ĂB
*	@return	ǗɋL^݂邩Ԃ܂B
*/
	virtual bool IsExistRecord(unsigned int Iterator) const = 0;	//ǂ𔻒
	//ÕCe[^
/**
*	@brief	ǗÕCe[^Z܂B
*
*			Ce[^Ƃ́AǗO̎QƈʒûƂłB<br>
*			Ce[^͈̔͂1`\link	nsAbyssLib::nsTextManager::ITextManager::GetKidokuMaxLog	GetKidokuMaxLog\endlink\bhŎ擾lƂȂ܂A͈͊Ȍꍇ͋Iɔ͈͓ɐݒ肳܂B
*	@param	Iterator	[in]Zlw肵܂B
*/
	virtual void AddReadIterator(int Iterator) = 0;					//Ce[^
/**
*	@brief	ǗÕCe[^擾܂B
*
*			Ce[^Ƃ́AǗO̎QƈʒûƂłB
*	@return	ǗÕCe[^Ԃ܂B
*/
	virtual unsigned int GetReadIterator() const = 0;				//Ce[^擾
/**
*	@brief	ǗÕCe[^ݒ肵܂B
*
*			Ce[^Ƃ́AǗO̎QƈʒûƂłB<br>
*			Ce[^͈̔͂1`\link	nsAbyssLib::nsTextManager::ITextManager::GetKidokuMaxLog	GetKidokuMaxLog\endlink\bhŎ擾lƂȂ܂A͈͊Ȍꍇ͋Iɔ͈͓ɐݒ肳܂B
*	@param	Iterator	[in]ݒlw肵܂B
*/
	virtual void SetReadIterator(unsigned int Iterator) = 0;		//Ce[^ݒ
	//O
/**
*	@brief	ǗOS܂B
*/
	virtual void ClearRecordData() = 0;								//O
/**
*	@brief	ǗO󂩂擾܂B
*	@return	ǗO󂩂Ԃ܂B
*/
	virtual bool IsEmptyRecordData() const = 0;						//O󂩁H
/**
*	@brief	O擾܂B
*
*			ǂ̃O擾邩́A\\link	nsAbyssLib::nsTextManager::ITextManager::AddReadIterator	AddReadIterator\endlink\bh
*			邢\link	nsAbyssLib::nsTextManager::ITextManager::SetReadIterator	SetReadIterator\endlink\bhŐݒ肵܂B<br>
*			ǗȌꍇA\link	nsAbyssLib::nsFMisc::RuntimeError	^CG[\endlink܂B
*	@return	OԂ܂B
*/
	virtual const Record& GetRecordData() const = 0;				//O擾
/**
*	@brief	Oǉ܂B
*	@param	Data	[in]ǉ郍Ow肵܂B
*/
	virtual void AddRecordData(const Record& Data) = 0;				//Oǉ
};

//ǗǗ
/**
*	@brief	ǗǗNXłB
*
*			{NX͑SĂ̊ǗǗs܂B
*/
class TextManager : public ITextManager{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	TextManager();													//ftHgRXgN^

/**
*	@brief	s܂B
*/
	void Initialize();												//

	bool GetSkip() const;											//XLbv擾
	void SetSkip(bool IsSkip);										//XLbvݒ

	bool GetForceSkip() const;										//XLbv擾
	void SetForceSkip(bool IsForceSkip);							//XLbvݒ

	bool GetAutoMode() const;										//I[g[h̗L擾
	void SetAutoMode(bool IsAutoMode);								//I[g[h̗Lݒ

	unsigned int GetAutoModeTime() const;							//I[g[h̑ҋ@Ԃ擾
	void SetAutoModeTime(unsigned int Time);						//I[g[h̑ҋ@Ԃݒ

	unsigned int GetKidokuMaxLog() const;							//O̍őێ擾
	void SetKidokuMaxLog(unsigned int NumMaxLog);					//O̍őێݒ

	void AddRecord(unsigned int Iterator);							//L^ɒǉ
	bool IsExistRecord(unsigned int Iterator) const;				//ǂ𔻒

	void AddReadIterator(int Iterator);								//Ce[^
	unsigned int GetReadIterator() const;							//Ce[^擾
	void SetReadIterator(unsigned int Iterator);					//Ce[^ݒ

	void ClearRecordData();											//O
	bool IsEmptyRecordData() const;									//O󂩁H
	const Record& GetRecordData() const;							//O擾
	void AddRecordData(const Record& Data);							//Oǉ

/**
*	@brief	ݒ̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void SaveE(IIOStream* IOStream);								//ۑiݒj
/**
*	@brief	ݒ̓ǂݍ݂s܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void LoadE(IIOStream* IOStream);								//ǂݍ݁iݒj
/**
*	@brief	Ǘ̕ۑs܂B
*	@param	FileName	[in]t@Cw肵܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	bool SaveK(const string& FileName, IIOStream* IOStream);		//ۑiǗj
/**
*	@brief	Ǘ̓ǂݍ݂s܂B
*	@param	FileName	[in]t@Cw肵܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	bool LoadK(const string& FileName, IIOStream* IOStream);		//ǂݍ݁iǗj
/**
*	@brief	[Jݒ̕ۑs܂B
*	@param	IOStream	[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void SaveL(IIOStream* IOStream);								//ۑi[Jj
/**
*	@brief	[Jݒ̓ǂݍ݂s܂B
*	@param	IOStream				[in]\link	nsAbyssLib::nsIOStream::IIOStream	f[^o̓NX\endlinkw肵܂B
*/
	void LoadL(IIOStream* IOStream);								//ǂݍ݁i[Jj
private:
	bool m_IsSkip;													//XLbv̗L
	bool m_ForceSkip;												//XLbv̗L
	bool m_IsAutoMode;												//I[g[h̗L
	unsigned int m_AutoModeTime;									//I[g[h̑ҋ@
	unsigned int m_KidokuMaxLog;									//O̍őێ
	vector<unsigned int> m_Record;									//ǋL^
	unsigned int m_ReadIterator;									//ÕCe[^
	vector<Record> m_RecordData;									//O

	TextManager(const TextManager&);								//Rs[RXgN^i֎~j
	TextManager& operator =(const TextManager&);					//Zqi֎~j
};

}
}

#endif