#include "stdafx.h"
#include "index.h"
#include "TextStream.h"

namespace nsAbyssLib{
namespace nsTextStream{

//ftHgRXgN^
FileTextStream::FileTextStream(){
	m_FileName = DEFAULT_FILE_ERRORLOG;
}
//RXgN^it@Cj
FileTextStream::FileTextStream(const string& FileName){
	m_FileName = FileName;
}
//o
void FileTextStream::Out(const Expression& t) const{
	for(unsigned int i=0;i<t.size();i++){
		if(t.at(i).Type==TK_CONST){
			Out("(%d)", t.at(i).Value);
		}
		else{
			Out("(%s)", t.at(i).Text.c_str());
		}
	}
}
//ɏ]o
void __cdecl FileTextStream::Out(LPCSTR fmt, ...) const{
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	FILE* stream = fopen(m_FileName.c_str(), "a");
	if(stream){
		fprintf(stream, "%s", buf);
		fclose(stream);
	}
}



//o
void ConsoleTextStream::Out(const Expression& t) const{
	for(unsigned int i=0;i<t.size();i++){
		if(t.at(i).Type==TK_CONST){
			Out("(%d)", t.at(i).Value);
		}
		else{
			Out("(%s)", t.at(i).Text.c_str());
		}
	}
}
//ɏ]o
void __cdecl ConsoleTextStream::Out(LPCSTR fmt, ...) const{
	char buf[65535];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	printf("%s", buf);
}

}
}