/*************************************************
t@CFTextStream.h
쐬ҁ@@Fт
@@@FeLXgo
*************************************************/
/**
*	@file	TextStream.h
*	@brief	eLXgo̓NX֌WłB
*/
#ifndef ABYSSLIB_TEXTSTREAM_H
#define ABYSSLIB_TEXTSTREAM_H

namespace nsAbyssLib{
namespace nsTextStream{

//eLXgo̓Xg[iC^[tF[Xj
/**
*	@brief	eLXgo̓Xg[̃C^[tF[XłB
*/
class ITextStream{
public:
/**
*	@brief	eLXgo͂܂B
*
*			eLXgo͂悤ɎĂB
*	@param	t	[in]eLXgo͑Ώۂ\link	nsAbyssLib::nsCMisc::Expression	NX\endlinkw肵܂B
*/
	virtual void Out(const Expression& t) const = 0;				//o
/**
*	@brief	eLXgo͂܂B
*
*			eLXgo͂悤ɎĂB
*	@param	fmt	[in]o͕w肵܂B<br>
*				printfƓ̏w肪\łB
*	@param	...	[in]o͂ϐw肵܂B<br>
*				printfƓ̏w肪\łB
*/
	virtual void __cdecl Out(LPCSTR fmt, ...) const = 0;			//ɏ]o
};

//eLXgo̓Xg[
/**
*	@brief	eLXgo̓Xg[̊NXłB
*
*			eLXgo̓Xg[쐬ۂɂ͕K{NXp悤ɂĂB
*/
class BaseTextStream : public ITextStream{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~BaseTextStream(){}										//zfXgN^

	//
	//	eLXgo̓\bh
	//
	//	EhꍇAȉ̓͕K邱
	//
	virtual void Out(const Expression& t) const = 0;				//o
	virtual void __cdecl Out(LPCSTR fmt, ...) const = 0;			//ɏ]o
};

//eLXgo̓Xg[it@Cj
/**
*	@brief	eLXgo̓Xg[̃t@CpłB
*
*			RXgN^Ŏw肵Õt@CɃeLXgo͂܂B
*/
class FileTextStream : public BaseTextStream{
public:
/**
*	@brief	ftHgRXgN^łB
*
*			t@C	::DEFAULT_FILE_ERRORLOG	w肵ƌȂ܂B
*/
	FileTextStream();												//ftHgRXgN^
/**
*	@brief	RXgN^łB
*	@param	FileName	[in]eLXgo͂t@Cw肵܂B
*/
	FileTextStream(const string& FileName);							//RXgN^it@Cj
	void Out(const Expression& t) const;							//o
	void __cdecl Out(LPCSTR fmt, ...) const;						//ɏ]o
private:
	string m_FileName;												//t@C
	FileTextStream(const FileTextStream&);							//Rs[RXgN^i֎~j
	FileTextStream& operator =(const FileTextStream&);				//Zqi֎~j
};

//eLXgo̓Xg[iR\[j
/**
*	@brief	eLXgo̓Xg[̃R\[płB
*/
class ConsoleTextStream : public BaseTextStream{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	ConsoleTextStream(){}											//ftHgRXgN^
	void Out(const Expression& t) const;							//o
	void __cdecl Out(LPCSTR fmt, ...) const;						//ɏ]o
private:
	ConsoleTextStream(const ConsoleTextStream&);					//Rs[RXgN^i֎~j
	ConsoleTextStream& operator =(const ConsoleTextStream&);		//Zqi֎~j
};

//eLXgo̓Xg[ikfoCXj
/**
*	@brief	eLXgo̓Xg[̃kfoCXłB
*
*			ikfoCXƂ́AuȂvNX̂Ƃłj
*/
class NullTextStream : public BaseTextStream{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	NullTextStream(){}												//ftHgRXgN^
	void Out(const Expression& t) const{}							//o
	void __cdecl Out(LPCSTR fmt, ...) const{}						//ɏ]o
private:
	NullTextStream(const NullTextStream&);							//Rs[RXgN^i֎~j
	NullTextStream& operator =(const NullTextStream&);				//Zqi֎~j
};

}
}

#endif